/*
 * Grammar.java
 *
 * Created on 11. Mai 2000, 21:36
 */
 
package YARB.FileSources.SNNS.ResultFiles;

import YARB.FileSources.SNNS.ResultFiles.TerminalSymbols;
import java.util.*;
/** 
 *
 * @author  Administrator
 * @version 
 */
public class Grammar extends TerminalSymbols {
  
  
  /** Creates new Grammar */
  public Grammar() {
  }
  
  protected int m_NoOfPattern=0,
                m_NoOfInput=0,
                m_NoOfOutput=0,
                m_NoOfVarIDim=0,
                m_NoOfVarODim=0,
                m_MaximumIDim[],
                m_MaximumODim[],
                m_InputPatternStreamLength=0, m_InputStreamLength=0,
                m_OutputPatternStreamLength=0,m_OutputStreamLength=0,
                m_CurrentInputPattern=0, m_CurrentOutputPattern=0,
                m_CurrentPatternData=0,
                m_Startpattern=0, m_Endpattern=0;
  
 protected boolean m_TeachingOutputIncluded=false;
 private   boolean m_PatternProcess=false;
 protected float m_InputData[][], m_OutputData[][];//
  
  protected void ShowParam() {
    String s = new String("");
    System.out.println("Status of pattern file: ");
    System.out.println("No. of patterns: " + s.valueOf(m_NoOfPattern));
    System.out.println("No. of input units:  " + s.valueOf(m_NoOfInput));
    System.out.println("No. of output units: " + s.valueOf(m_NoOfOutput));
    System.out.println("No. of variable input dimensions:  " + s.valueOf(m_NoOfVarIDim));
    System.out.print("Maximum input dimensions:  [ ");
    for( int i=0; i < m_NoOfVarIDim; i++) System.out.print(s.valueOf(m_MaximumIDim[i])+" ");
    System.out.println("]");    
    System.out.println("No. of variable output dimensions: " + s.valueOf(m_NoOfVarODim));
    System.out.print("Maximum output dimensions: [ ");
    for( int i=0; i < m_NoOfVarODim; i++) System.out.print(s.valueOf(m_MaximumODim[i])+" ");
    System.out.println("]");
    System.out.println("Streamlength of inputpattern:  " + s.valueOf(m_InputPatternStreamLength));
    System.out.println("Streamlength of total input:   " + s.valueOf(m_InputStreamLength));
    System.out.println("Streamlength of outputpattern: " + s.valueOf(m_OutputPatternStreamLength));
    System.out.println("Streamlength of total output:  " + s.valueOf(m_OutputStreamLength));
    System.out.println("Startpattern: " + s.valueOf(m_Startpattern));
    System.out.println("Endpattern: " + s.valueOf(m_Endpattern));
    System.out.println("Teaching output included: " + s.valueOf(m_TeachingOutputIncluded));
    int t=1;
    for( int i=0; i < m_NoOfVarIDim; i++) t = t * m_MaximumIDim[i];
    
    if( m_NoOfInput != 0 ) {
      System.out.println("Sample of input pattern data: ");      
      
      for( int i=0; i < m_NoOfPattern && i < 1; i++) {
        System.out.print("Inputpattern " + s.valueOf(i)+" :");
        for( int j=0; j < m_InputPatternStreamLength && j < 5 ; j++) {
          System.out.print(" "+s.valueOf(m_InputData[i][j]));
          if( t > 1 && j%t == 0 ) System.out.print("\n");
        }
        System.out.print("\n");
      }
    }
    
    if( m_NoOfOutput != 0 ) {
      System.out.println("Sample of output pattern data: ");      
      
      for( int i=0; i < m_NoOfPattern && i < 1; i++) {
        System.out.print("Outputpattern " + s.valueOf(i)+" :");
        for( int j=0; j < m_OutputPatternStreamLength && j < 5; j++) {
          System.out.print(" "+s.valueOf(m_OutputData[i][j]));
          if( t > 1 && j%t == 0 ) System.out.print("\n");
        }
        System.out.print("\n");
      }
    }    
  }

  /** convert a valid NUMBER to float type
   */
  private float ParseNumber(String s) {    
    try {      
      Float FLOAT = new Float(s);      
      return (FLOAT.floatValue());      
    } catch( NumberFormatException e ) {}
    try {
      Integer INTEGER = new Integer(s);
      return (float)INTEGER.intValue();      
    } catch( NumberFormatException e ) {}
    try {
      Long LONG = new Long(s);
      return (float)LONG.longValue();      
    } catch( NumberFormatException e ) {}
    return 0;
  }
  /** remove EOL from strings
    * remove '\n' and '\r'
    */
  private String removeEOL(String s)   
  throws NullPointerException { 
    if ( s == null || s.length() == 0){       
      throw new NullPointerException("***removeEOL: parameter  s.length() == 0 || s == null : " + this.toString());
    }
    try {            
      StringBuffer sb = new StringBuffer(s);      
      //System.out.println("("+sb.toString()+")");
      for ( int i=0;  i < sb.length() ; i++) {
        if ( sb.charAt(i) == '\n' || sb.charAt(i) == '\r' ) { 
          if( i > 0 ) {
            if( sb.charAt(i-1) == ' ') {
              sb.deleteCharAt(i); i--;
            }
            else sb.setCharAt(i,' ');                    
          }
          else {
            sb.deleteCharAt(i); i--;
          }
         
        } 
          //sb.deleteCharAt(i); i--; }          
      } 
      //System.out.println("("+sb.toString()+")");
      return sb.toString();
    } catch (StringIndexOutOfBoundsException e1) {
        System.out.println("***StringIndexOutOfBoundsException: " + e1.toString() + ": " + this.toString());        
    } 
    return null;
  }
  
  /** RemoveEmptyLines
    *
  */
  private String RemoveEmptyLines(String s)
  throws NullPointerException { 
    if ( s == null || s.length() == 0){       
      throw new NullPointerException("***RemoveEmtyLines: parameter  t.length() == 0 || t == null : " + this.toString());
    }
    try {        
      StringBuffer sb = new StringBuffer(s);
      // Replace '\r' with '\n'
      for( int i=0; i < sb.length(); i++) {
        if( sb.charAt(i) == '\r') sb.setCharAt(i,'\n');              
      } 
      int k=0;
      // Delete empty lines
      for( int i=0,j=0; i < sb.length() ; i++) {
        if( sb.charAt(i) == '\n') {        
          if( j == 0 ) {
            sb.deleteCharAt(i);
            i--;
          }
          else j=0;
        }
        else j++;
      }    
      return sb.toString();
    } catch (StringIndexOutOfBoundsException e1) {
        System.out.println("***StringIndexOutOfBoundsException: " + e1.toString()+ ": " + this.toString());                
    }                        
    return null;
  }
  
  /** pattern_entry ::= NUMBER
  */  
  private boolean pattern_entry(String s)
  throws NullPointerException { 
    if ( s == null || s.length() == 0){       
      throw new NullPointerException("***pattern_entry: parameter  s.length() == 0 || s == null : " + this.toString());
    }
    try {    
      return NUMBER(s);
    } catch (StringIndexOutOfBoundsException e1) {
        System.out.println("***StringIndexOutOfBoundsException: " + e1.toString()+ ": " + this.toString());
    } catch (NullPointerException e2) {
        System.out.println("***NullPointerException: " + e2.toString());
    }
    return false;                    
  }
  
  /** pattern_body ::= pattern_entry | (pattern_body pattern_entry)
    * i.e: #Input Data
    *      1 2 3 EOL
    *      4 5 6 EOL
    *      7 8 9 EOL
    * pattern_body :"1 2 3 4 5 6 7 8 9 "
  */
  private boolean pattern_body(String s)
  throws NullPointerException { 
    if ( s == null || s.length() == 0){       
      throw new NullPointerException("***pattern_body: parameter  s.length() == 0 || s == null");
    }
    try {            
      if( s.charAt(s.length()-1) != ' ' ) return false;      
      m_CurrentPatternData=0;
      int j=-1, ncnt=0;
      for (int i=0; i < s.length(); ) {
        if ( s.charAt(i) != ' ' ) {
          // Get substrings
          j=i;  
          for( ;s.charAt(i) != ' ' && i < s.length()-1; i++);
          //System.out.println(s.valueOf(j)+","+s.valueOf(i));          
          if ( !NUMBER(s.substring(j,i)) ) return false;
          if( m_NoOfInput != 0 ) {
            if( m_NoOfOutput == 0 || m_PatternProcess == false ) {
              //InputData[m_CurrentInputPattern*m_InputPatternStreamLength + CurrentPatternData] = ParseNumber(s.substring(j,i)); //CurrentPatternData;
              m_InputData[m_CurrentInputPattern][m_CurrentPatternData] = ParseNumber(s.substring(j,i)); //CurrentPatternData;
              m_CurrentPatternData++;
            }
          }
          if( m_NoOfOutput != 0 ) {
            if( m_NoOfInput == 0 || m_PatternProcess == true ) {
              //OutputData[CurrentOutputPattern*m_OutputPatternStreamLength + CurrentPatternData] = ParseNumber(s.substring(j,i)); //CurrentPatternData;
              m_OutputData[m_CurrentOutputPattern][m_CurrentPatternData] = ParseNumber(s.substring(j,i)); //CurrentPatternData;
              m_CurrentPatternData++;
            }
          }
          
        }
        else i++;
      }
      
      // Only whitespaces in string    
      if ( j == -1 ) return false;
      if( !m_PatternProcess  ) {
        if( m_NoOfOutput != 0 ) m_PatternProcess=true;
        m_CurrentInputPattern++;
      }
      else {
        m_CurrentOutputPattern++;
        if( m_NoOfInput != 0 ) m_PatternProcess=false;
      }
      return true;
      
    } catch (StringIndexOutOfBoundsException e1) {
        System.out.println("***StringIndexOutOfBoundsException: " + e1.toString()+ ": " + this.toString());                
    } catch (NullPointerException e2) {
        System.out.println("***NullPointerException: " + e2.toString());
    }
    return false;    
  }

  /** dim_entry ;;= INT
   */
  private boolean dim_entry(char c) {
    return INT(c);
  }
  
  /** actual_dim_rest ;;= dim_entry | (actual_dim_rest din_entry)
   */
  private boolean actual_dim_rest(String s)
  throws NullPointerException { 
    if ( s == null || s.length() == 0){       
      throw new NullPointerException("***actual_dim_rest: parameter  s.length() == 0 || s == null : " + this.toString());
    }
    try {        
      int num_cnt=0;
      for ( int i=0; i < s.length() ; i++) {
        if ( !dim_entry(s.charAt(i)) )  {
          if ( s.charAt(i) != ' ' ) return false;
          else if( i == 0 || i == s.length()-1 ) return false;
        }
        else num_cnt++;
      }
      return true;
    } catch (StringIndexOutOfBoundsException e1) {
        System.out.println("***StringIndexOutOfBoundsException: " + e1.toString()+ ": " + this.toString());                
    } catch (NullPointerException e2) {
        System.out.println("***NullPointerException: " + e2.toString());
    }
    return false;
  }  

  /** actual_dim ;;= (L_BRACKET actual_dim_rest R_BRACKET) | (L_BRACKET R_BRACKET)
   * [ 1 2 3 4 ], [ ]
   */
  private boolean actual_dim(String s)
  throws NullPointerException { 
    if ( s == null || s.length() < 3){       
      throw new NullPointerException("***actual_dim: parameter  s.length() < 3 || s == null : " + this.toString());
    }
    try {        
      if( s.length() == 3 ) { 
        if( s.compareTo("[ ]") == 0 ) return true;
        else return false;
      }
      if ( !L_BRACKET(s.charAt(0)) || !R_BRACKET(s.charAt(s.length()-1)) ) return false;
      if ( s.charAt(1) != ' ' || s.charAt(s.length()-2) != ' ' ) return false;
      if ( !actual_dim_rest(s.substring(2,s.length()-2)) ) return false;
      return true;
    } catch (StringIndexOutOfBoundsException e1) {
        System.out.println("***StringIndexOutOfBoundsException: " + e1.toString()+ ": " + this.toString());                
    } catch (NullPointerException e2) {
        System.out.println("***NullPointerException: " + e2.toString());
    } 
    return false;
  }
  
  
  /** pattern_start ;;= [Comment] [actual_dim]
   * #sdfsdasdasd\n[ 12 ]\n
   */
  private boolean pattern_start(String s) {     
    try {
      String t;
      if ( s.length() == 0 ) return true;          
      if( s.charAt(s.length()-1) != '\n' ) return false;    
      int tmp=0;
        for( int j=0,i=0; i < s.length(); i++) {      
        if ( s.charAt(i) == '\n' ) {        
          // Comment has to be the first substring 
          if ( j == 0 ) {
            if ( COMMENT(s.substring(j,i+1)) ) j=i;
            else {
              // No Comment, only actual_dim
              if( i == s.length()-1 ) {
                t = s.substring(j,i);
                if( t.charAt(0) != '[' ) return false;
                if( !actual_dim(t) ) return false;
              }
              else return false;
            }
          }
          else {
            if( i == s.length()-1 ) {
              t = s.substring(j+1,i);
              if( t.charAt(0) != '[' ) return false;
              if( !actual_dim(t) ) return false;
            }
            else return false;
          }          
        }                
      }    
      return true;
    } catch (StringIndexOutOfBoundsException e1) {
        System.out.println("***StringIndexOutOfBoundsException: " + e1.toString()+ ": " + this.toString());                
    } catch (NullPointerException e2) {
        System.out.println("***NullPointerException: " + e2.toString());
    } 
    return false;      
  } 
  
  /** pattern ::= pattern_start pattern_body
    * # Input patterm
    * [ 5 ]
    * 1 2 3 4 5 EOL
    * 6 7 8 9 0 EOL
    * ...
    */
  private boolean pattern(String s)
  throws NullPointerException { 
    if ( s == null || s.length() == 0 ){       
      throw new NullPointerException("***pattern: parameter  s.length() == 0 || s == null : " + this.toString());
    }
    try {        
      int psl1=0, psl2=0, ps=0;
      String tmp;
      // Check pattern_start
      if( s.charAt(s.length()-1) != '\n' ) return false;    
      
      if ( pattern_body(removeEOL(s)) ) return true;
      
      //System.out.println("Pattern ...");
      for( int i=0; i < s.length() ; i++) {
        if( s.charAt(i) == '\n' ) {        
          // Check until second EOL        
          ps++;                
          if ( pattern_start(s.substring(0,i+1)) ) {          
            //System.out.println("("+s.substring(0,i+1)+")");            
            if ( psl1 == 0 ) psl1=i;
            else psl2=i;          
          }
          if (ps == 2) {
            // finished pattern_start control
            //tmp = removeEOL(s.substring(psl2+1,s.length()));            
            //System.out.println("("+tmp+")");
            //if ( tmp == null ) return false;
            
            if ( psl1 > 0 ) {
              // Only the first line is the pattern_start
              if ( psl2 > 0 ) {
                //System.out.println("No pattern start 2");
                // pattern_start consists of 2 lines                              
                tmp = removeEOL(s.substring(psl2+1,s.length()));
                //System.out.println(tmp);
                if ( pattern_body(tmp) ) return true;
                else return false;
              }
              else {              
                //System.out.println("No pattern start 1");
                tmp = removeEOL(s.substring(psl1+1,s.length()));
                if ( pattern_body(tmp) ) return true;
                else return false;
              }
            }
            // No pattern_start, use whole string
            else {
              //System.out.println("No pattern start");
              if ( pattern_body(removeEOL(s)) ) return true;
              else return false;
            }
          }
        }      
      }
    } catch (StringIndexOutOfBoundsException e1) {
        System.out.println("***StringIndexOutOfBoundsException: " + e1.toString()+ ": " + this.toString());                
    } catch (NullPointerException e2) {
        System.out.println("***NullPointerException: " + e2.toString());
    }       
    return false;
  }
  
  
  /** patter_list ::= pattern | (patter_list pattern)
    *
    */
  public boolean pattern_list(String s)
  throws NullPointerException { 
    if ( s == null || s.length() == 0 ) {       
      throw new NullPointerException("***pattern_list: parameter  s.length() == 0 || s == null : " + this.toString());
    }
    try {      
      int j,i,n;
      boolean PatternAlreadyProcessed=false;
      int CurrentPattern = 0;
      int PBF=0; //PatternBodyFound
      // Setup data holder
      if( m_TeachingOutputIncluded ) {
        //InputData = new float[m_InputStreamLength];
        m_NoOfInput = m_NoOfOutput;
        m_InputPatternStreamLength = m_OutputPatternStreamLength;
        m_InputStreamLength = m_OutputStreamLength;
        m_InputData = new float[m_NoOfPattern][m_OutputPatternStreamLength];
        m_PatternProcess = false;
      }
      else {
        m_PatternProcess = true;
        m_NoOfInput=0;
      }
      
      if( m_NoOfOutput != 0 ) {
        //OutputData = new float[m_OutputStreamLength];
        m_OutputData = new float[m_NoOfPattern][m_OutputPatternStreamLength];
      }
      
      for( i=0,j=0; i < s.length(); ) {
        
        if( PBF == 0 ) {
          j=i;
          if( s.charAt(i) == '#' ) {
            PBF = 1;
            // jumb to next line
            for( ; i < s.length() && s.charAt(i) != '\n'; i++) ;
            
            // End of string reached -> error
            if( i == s.length() ) return false;
            
            if( s.charAt(i+1) == '[' ) {
              i++;
              for( ; i < s.length() && s.charAt(i) != '\n'; i++) ;
              // End of string reached -> error
              if( i == s.length() ) return false;              
            }
            //System.out.println("("+s.substring(j,i+1)+")");
          }
          else { 
            if( s.charAt(i) == '[' ) {
              PBF = 2;
              for( ; i < s.length() && s.charAt(i) != '\n'; i++) ;
              // End of string reached -> error
              if( i == s.length() ) return false;
              //System.out.println("("+s.substring(j,i+1)+")");
            }
            else {
              PBF = -1;
            }
          }
        }
        else {
          if( m_PatternProcess ) CurrentPattern = m_OutputPatternStreamLength;                    
          else CurrentPattern = m_InputPatternStreamLength;
          //CurrentPattern=2;          
          // Count no of I/O Numbers
          
          for( n=0; i < s.length() && n < CurrentPattern; i++) {            
            if( s.charAt(i) == ' ' ) n++;
            else {
              // Check if last number ended with space
              if( s.charAt(i) == '\n' ) {
                if( s.charAt(i-1) != ' ' ) n++;                
              }
            }          
          }          
          if( n < CurrentPattern) return false;
          if( i == s.length() ) i--;
          
          //System.out.println("("+s.substring(j,i+1)+")");
          // goto EOL
          if( s.charAt(i) != '\n' ) {
            if( s.charAt(i) != ' ' && CurrentPattern > 1 ) i--;
            for( ; i < s.length() && s.charAt(i) != '\n'; i++) ;
            if( i == s.length() ) {
              if( s.charAt(i-1) != '\n' ) return false;
            }
            else {
              if( s.charAt(i) != '\n' ) return false;
            }
          }
          // Check if pattern is valid                    
          //System.out.println("("+s.substring(j,i+1)+")");
          if ( !pattern(s.substring(j,i+1)) ) return false;          
          //System.out.println("valid");          
          
          PBF=0; 
          //if( i < s.length() ) 
          i++;
        }        
      }
      return true;
      /*
      for( i=1,j=0; i < s.length(); i++) {        
        if( s.charAt(i) == '#' ) {
          //System.out.println("patter_list: "+s.substring(j,i));
          //System.out.println("Validating pattern...");
          if ( !pattern(s.substring(j,i)) ) return false;
          PatternAlreadyProcessed = true;
          j=i;
        }
      }
      // Check last pattern
      //System.out.println("("+s.substring(j,i)+")");
      if ( pattern(s.substring(j,i)) ) return true;
      */
      
    } catch (StringIndexOutOfBoundsException e1) {
        System.out.println("***StringIndexOutOfBoundsException: " + e1.toString());                
    } catch (NullPointerException e2) {
        System.out.println("***NullPointerException: " + e2.toString());
    }             
    return false;
  }
  
  /** i_head ::= [Comment] NO_OF_INPUT NUMBER
    * #Comment\n
    * No. of input units : 1\n
    */
  private boolean i_head(String s)
  throws NullPointerException { 
    if ( s == null || s.length() == 0){       
      throw new NullPointerException("***i_head: parameter  s.length() == 0 || s == null : " + this.toString());
    }
    try {        
      if( s.charAt(s.length()-1) != '\n' ) return false;    
      String num;
      for( int j=0,i=0; i < s.length(); i++ ) {
        // Check COMMENT
        if ( s.charAt(0) == '#' && s.charAt(i) == '\n' && j == 0) {
          j=i;
          if( !COMMENT(s.substring(0,i+1)) ) return false;                
        }
        if( s.charAt(i) == ':' ) {
          if( i == s.length()-2 ) return false;
          if ( j != 0 ) j++;         
          if( !NO_OF_INPUT(s.substring(j,i+1)) ) return false;
          num=s.substring(i+2,s.length()-1);
          if( !NUMBER(num) ) return false;          
          m_NoOfInput=(int)ParseNumber(num);
          m_InputPatternStreamLength=m_NoOfInput;
          m_InputStreamLength=m_InputPatternStreamLength*m_NoOfPattern;
          return true;
        }
      }
    } catch (StringIndexOutOfBoundsException e1) {
        System.out.println("***StringIndexOutOfBoundsException: " + e1.toString()+ ": " + this.toString());                
    } catch (NullPointerException e2) {
        System.out.println("***NullPointerException: " + e2.toString());
    }      
    return false;    
  }
  
 /** o_head ::= [Comment] NO_OF_OUTPUT NUMBER
    * #Comment\n
    * No. of input units : 1\n
    */
  private boolean o_head(String s) 
  throws NullPointerException { 
    if ( s == null || s.length() == 0){       
      throw new NullPointerException("***o_head: parameter  s.length() == 0 || s == null : " + this.toString());
    }
    try {        
      if( s.charAt(s.length()-1) != '\n' ) return false;
    
      for( int j=0,i=0; i < s.length(); i++ ) {
        // Check COMMENT
        if ( s.charAt(0) == '#' && s.charAt(i) == '\n' && j == 0) {
          j=i;
          if( !COMMENT(s.substring(0,i+1)) ) return false;                
        }
        if( s.charAt(i) == ':' ) {
        if( i == s.length()-2 ) return false;
        if( j != 0 ) j++;         
        if( !NO_OF_OUTPUT(s.substring(j,i+1)) ) return false;
        if( !NUMBER(s.substring(i+2,s.length()-1)) ) return false;
        m_NoOfOutput=(int)ParseNumber(s.substring(i+2,s.length()-1));
        m_OutputPatternStreamLength=m_NoOfOutput;
        m_OutputStreamLength=m_OutputPatternStreamLength*m_NoOfPattern;
        return true;
        }
      }
    } catch (StringIndexOutOfBoundsException e1) {
        System.out.println("***StringIndexOutOfBoundsException: " + e1.toString()+ ": " + this.toString());                
    } catch (NullPointerException e2) {
        System.out.println("***NullPointerException: " + e2.toString());
    }            
    return false;    
  }
  
 /** start_pattern ::= [Comment] START_PATTERN NUMBER
    * #Comment\n
    * startpattern : 1\n
    */
  private boolean start_pattern(String s) 
  throws NullPointerException { 
    if ( s == null || s.length() == 0){       
      throw new NullPointerException("***start_pattern: parameter  s.length() == 0 || s == null : " + this.toString());
    }
    try {        
      if( s.charAt(s.length()-1) != '\n' ) return false;
    
      for( int j=0,i=0; i < s.length(); i++ ) {
        // Check COMMENT
        if ( s.charAt(0) == '#' && s.charAt(i) == '\n' && j == 0) {
          j=i;
          if( !COMMENT(s.substring(0,i+1)) ) return false;                
        }
        if( s.charAt(i) == ':' ) {
        if( i == s.length()-2 ) return false;
        if( j != 0 ) j++;         
        if( !START_PATTERN(s.substring(j,i+1)) ) return false;
        if( !NUMBER(s.substring(i+2,s.length()-1)) ) return false;
        m_Startpattern=(int)ParseNumber(s.substring(i+2,s.length()-1));
        return true;
        }
      }
    } catch (StringIndexOutOfBoundsException e1) {
        System.out.println("***StringIndexOutOfBoundsException: " + e1.toString()+ ": " + this.toString());                
    } catch (NullPointerException e2) {
        System.out.println("***NullPointerException: " + e2.toString());
    }            
    return false;    
  }
  
 /**  end_pattern ::= [Comment] END_PATTERN NUMBER
    * #Comment\n
    * endpattern : 1\n
    */
  private boolean end_pattern(String s) 
  throws NullPointerException { 
    if ( s == null || s.length() == 0){       
      throw new NullPointerException("***end_pattern: parameter  s.length() == 0 || s == null : " + this.toString());
    }
    try {        
      if( s.charAt(s.length()-1) != '\n' ) return false;
    
      for( int j=0,i=0; i < s.length(); i++ ) {
        // Check COMMENT
        if ( s.charAt(0) == '#' && s.charAt(i) == '\n' && j == 0) {
          j=i;
          if( !COMMENT(s.substring(0,i+1)) ) return false;                
        }
        if( s.charAt(i) == ':' ) {
        if( i == s.length()-2 ) return false;
        if( j != 0 ) j++;         
        if( !END_PATTERN(s.substring(j,i+1)) ) return false;
        if( !NUMBER(s.substring(i+2,s.length()-1)) ) return false;
        m_Endpattern=(int)ParseNumber(s.substring(i+2,s.length()-1));
        return true;
        }
      }
    } catch (StringIndexOutOfBoundsException e1) {
        System.out.println("***StringIndexOutOfBoundsException: " + e1.toString()+ ": " + this.toString());                
    } catch (NullPointerException e2) {
        System.out.println("***NullPointerException: " + e2.toString());
    }            
    return false;    
  }

  
  /** vi_head ::= [Comment] NO_OF_VAR_IDIM NUMBER MAXIMUM_IDIM actual_dim
    * "#comment\n
    *  No. of variable input dimensions : 2\n
    *  Maximum input dimensions : [ 223 171 ]\n"
    */
  private boolean vi_head(String s)
  throws NullPointerException { 
    if ( s == null || s.length() == 0){       
      throw new NullPointerException("***vi_head: parameter  s.length() == 0 || s == null : " + this.toString());
    }
    try {        
      if( s.charAt(s.length()-1) != '\n' ) return false;
      String tmp = new String("");
      for( int k=0,l=0,j=0,i=0; i < s.length(); i++ ) {
        // Check COMMENT
        if ( s.charAt(0) == '#' && s.charAt(i) == '\n' && j == 0) {
          j=i;
          if( !COMMENT(s.substring(0,i+1)) ) return false;
          //System.out.println(s.substring(0,i+1));
        }
        else {
          if( s.charAt(i) == '\n' ) {
            if( j != 0 ) j++;
            k++;
            tmp=s.substring(j,i);
            //System.out.println("("+tmp+")");          
            for ( l=0; l < tmp.length() && tmp.charAt(l) != ':' ; l++) ;
            if ( l == tmp.length() || tmp.charAt(tmp.length()-1) == ':' ) return false;
            if( k == 1 ) {            
              if( !NO_OF_VAR_IDIM(tmp.substring(0,l+1)) ) return false;
              //System.out.println("("+tmp.substring(0,l+1)+")");
              if( !NUMBER(tmp.substring(l+2,tmp.length())) ) return false;
              m_NoOfVarIDim=(int)ParseNumber(tmp.substring(l+2,tmp.length()));
              m_MaximumIDim = new int[m_NoOfVarIDim];
              //System.out.println("("+tmp.substring(l+2,tmp.length())+")");
            }
            if( k == 2 ) {
              if( !MAXIMUM_IDIM(tmp.substring(0,l+1)) ) return false;
              //System.out.println("("+tmp.substring(0,l+1)+")");
              if( !actual_dim(tmp.substring(l+2,tmp.length())) ) return false;
              // Get Dimensions
              String dim = new String(tmp.substring(l+2,tmp.length()));
              for( int a=1,b=0,c=0; a < dim.length()-1 && c < m_NoOfVarIDim; a++) {
                if( dim.charAt(a) != ' ') {
                  if( b == 0 ) b=a;
                }
                else {
                  if( b != 0 ) {
                    m_MaximumIDim[c]=(int)ParseNumber(dim.substring(b,a));
                    m_InputPatternStreamLength=m_InputPatternStreamLength*m_MaximumIDim[c];
                    b=0; c++;
                  }
                }
              }
              m_InputStreamLength=m_NoOfPattern*m_InputPatternStreamLength;
              //System.out.println("("+tmp.substring(l+2,tmp.length())+")");
              if ( i != s.length()-1 ) return false;
              return true;           
            }          
            j=i;
          }
        }
      }
    } catch (StringIndexOutOfBoundsException e1) {
        System.out.println("***StringIndexOutOfBoundsException: " + e1.toString()+ ": " + this.toString());
    } catch (NullPointerException e2) {
        System.out.println("***NullPointerException: " + e2.toString());
    }                  
    return false;
  }
  
  /** vo_head ::= [Comment] NO_OF_VAR_ODIM NUMBER MAXIMUM_ODIM actual_dim
    * "#comment\n
    *  No. of variable output dimensions : 2\n
    *  Maximum output dimensions : [ 223 171 ]\n"
    */
  private boolean vo_head(String s)
  throws NullPointerException { 
    if ( s == null || s.length() == 0){       
      throw new NullPointerException("***vo_head: parameter  s.length() == 0 || s == null : " + this.toString());
    }
    try {        
      if( s.charAt(s.length()-1) != '\n' ) return false;
      String tmp;
      for( int l=0,k=0,j=0,i=0; i < s.length(); i++ ) {
        // Check COMMENT
        if ( s.charAt(0) == '#' && s.charAt(i) == '\n' && j == 0) {
          j=i;
          if( !COMMENT(s.substring(0,i+1)) ) return false;
          //System.out.println(s.substring(0,i+1));
        }
        else {
          if( s.charAt(i) == '\n' ) {
            if( j != 0 ) j++;
            k++;
            tmp=s.substring(j,i);
            //System.out.println("("+tmp+")");          
            for ( l=0; l < tmp.length() && tmp.charAt(l) != ':' ; l++) ;
            if ( l == tmp.length() || tmp.charAt(tmp.length()-1) == ':' ) return false;
            if( k == 1 ) {            
              if( !NO_OF_VAR_ODIM(tmp.substring(0,l+1)) ) return false;
              //System.out.println("("+tmp.substring(0,l+1)+")");
              if( !NUMBER(tmp.substring(l+2,tmp.length())) ) return false;
              m_NoOfVarODim=(int)ParseNumber(tmp.substring(l+2,tmp.length()));
              m_MaximumODim = new int[m_NoOfVarODim];
              //System.out.println("("+tmp.substring(l+2,tmp.length())+")");
            }
            if( k == 2 ) {
              if( !MAXIMUM_ODIM(tmp.substring(0,l+1)) ) return false;
              //System.out.println("("+tmp.substring(0,l+1)+")");
              if( !actual_dim(tmp.substring(l+2,tmp.length())) ) return false;
              // Get Dimensions
              String dim = new String(tmp.substring(l+2,tmp.length()));
              for( int a=1,b=0,c=0; a < dim.length()-1 && c < m_NoOfVarODim; a++) {
                if( dim.charAt(a) != ' ') {
                  if( b == 0 ) b=a;
                }
                else {
                  if( b != 0 ) {
                    m_MaximumODim[c]=(int)ParseNumber(dim.substring(b,a));
                    m_OutputPatternStreamLength=m_OutputPatternStreamLength*m_MaximumODim[c];
                    b=0; c++;
                  }
                }
              }  
              m_OutputStreamLength=m_NoOfPattern*m_OutputPatternStreamLength;
              //System.out.println("("+tmp.substring(l+2,tmp.length())+")");
              if ( i != s.length()-1 ) return false;
              return true;           
            }          
            j=i;
          }
        }
      }
    } catch (StringIndexOutOfBoundsException e1) {
        System.out.println("***StringIndexOutOfBoundsException: " + e1.toString()+ ": " + this.toString());
    } catch (NullPointerException e2) {
        System.out.println("***NullPointerException: " + e2.toString());
    }                        
    return false;
  }
  
  /** header ::= VERSION_HEADER V_NUMBER GENERATED_AT NO_OF_PATTERN NUMBER i_head [o_head] [vi_head] [vo_head] [start_pattern] [end_pattern] [TEACHING_OUTPUT_INCLUDED]
    * "SNNS pattern definition file V3.2\n
       generated at Thu Apr 21 17:59:47 1994 by pnm2pat\n
       No. of patterns : 1\n
       No. of input units : 1\n
       No. of output units : 2\n
       No. of variable input dimensions : 2\n
       Maximum input dimensions : [ 223 171 ]\n
       No. of variable output dimensions : 2\n
       Maximum output dimensions : [ 221 169 ]\n
       startpattern        : 1\n
       endpattern          : 26\n
       teaching output included\n"
    */
    
  private boolean header(String t)
  throws NullPointerException { 
    if ( t == null || t.length() == 0){       
      throw new NullPointerException("***header: parameter  t.length() == 0 || t == null : " + this.toString());
    }
    try {        
      if( t.charAt(t.length()-1) != '\n') return false;    
      int check=0;
      String tmp;
      String s = new String(t+" ");
      boolean O_HEAD=false, PROCESS_FLAG=false;
    
      for(int i=0,j=0,l=0; i < s.length() ; i++) {
        // VERSION_HEADER
        if( i == "SNNS result file".length() ) {
          tmp = s.substring(j,i);
          if( !VERSION_HEADER(tmp) ) return false;        
          //System.out.println("("+tmp+"),check:"+s.valueOf(check)+",j:"+s.valueOf(j)+",i:"+s.valueOf(i));        
          //System.out.println(s.valueOf(check));
          check++; j=i+1;        
        }      
        if( s.charAt(i) == '\n' && i < s.length()-1) {
          //V_NUMBER        
          if( check == 1 ) {          
            //System.out.println(s.valueOf(check));
            tmp = s.substring(j,i);
            //if( !V_NUMBER(tmp) ) return false;          
            //System.out.println("("+tmp+"),check:"+s.valueOf(check)+",j:"+s.valueOf(j)+",i:"+s.valueOf(i));          
          }
          // GENERATED_AT
          if( check == 2 ) {
            // EOL needed
            tmp = s.substring(j,i+1);          
            if( !GENERATED_AT(tmp) ) return false;
            //System.out.println("("+tmp+"),check:"+s.valueOf(check)+",j:"+s.valueOf(j)+",i:"+s.valueOf(i));          
            //System.out.println(s.valueOf(check));
          }
          // NO_OF_PATTERN NUMBER
          if( check == 3 ) {
            tmp = s.substring(j,i);          
            for( int k=0; k < tmp.length(); k++) {
              if( tmp.charAt(k) == ':' ) {
                if( !NO_OF_PATTERN(tmp.substring(0,k+1)) ) return false;              
                if( k+2 >= tmp.length() ) return false;
                if( !NUMBER(tmp.substring(k+2,tmp.length())) ) return false;
                m_NoOfPattern=(int)ParseNumber(tmp.substring(k+2,tmp.length()));
                break; 
              }
            }
            //System.out.println("("+tmp+")");
            //System.out.println(s.valueOf(check));
          }
          // i_head
          if( check == 4 || check == 5 ) {            
            // check for optional comment
            if( check == 4 ) {
              PROCESS_FLAG=true;
              tmp = s.substring(j,i+1);
              if( tmp.charAt(0) != '#' ) {
                if( !i_head(tmp) ) return false;
                PROCESS_FLAG=false;
                check++;
              }
              else l=j;              
            }
            else {
              tmp = s.substring(l,i+1);
              if( !i_head(tmp) ) return false;
              PROCESS_FLAG=false;
            }
            //System.out.println("("+tmp+")");
            //System.out.println(s.valueOf(check));
          }
          // [o_head] or [vi_head] or [start_pattern]
          if( check == 6  || check == 7 || check == 8) {
            // check for optional comment
            if( check == 6 ) {
              PROCESS_FLAG=true;
              tmp =  s.substring(j,i+1);
              l=j;
              if( tmp.charAt(0) != '#' ) {
                if( o_head(tmp) ){
                  PROCESS_FLAG=false;
                  check+=2;                
                  O_HEAD=true;
                }
                else {
                  if( start_pattern(tmp) ) {
                    PROCESS_FLAG=false;
                    check+=2;
                  }
                }
              }
              //System.out.println("("+tmp+")");
            }
            else {
              if( check == 7 ) {
                tmp = s.substring(l,i+1);
                if( tmp.charAt(0) == '#') {
                  if( o_head(tmp) ) {
                    PROCESS_FLAG=false;
                    check++;
                    O_HEAD=true;
                  }          
                  else {
                    if( start_pattern(tmp) ) {
                      PROCESS_FLAG=false;
                      check++;
                    }
                  }
                }
                else {
                  if( !vi_head(tmp) ) return false;
                  check++;
                  PROCESS_FLAG=false;
                }
                //System.out.println("("+tmp+")");
              }
              else {
                tmp = s.substring(l,i+1);
                if( !vi_head(tmp) ) return false;
                PROCESS_FLAG=false;
                //System.out.println("("+tmp+")");
              }
            }
            //System.out.println(s.valueOf(check));
          }
           
          // [vi_head] or ( [vo_head] -> if o_head occured ) or start_pattern or end_pattern
          if( check == 9 || check == 10 || check == 11 ) {
            if( check == 9 ) {
              PROCESS_FLAG=true;
              tmp =  s.substring(j,i+1);
              l=j;
              if( tmp.charAt(0) != '#' ) {
                if( start_pattern(tmp) ){
                  PROCESS_FLAG=false;
                  check+=2;                                  
                }
                else {
                  if( end_pattern(tmp) ) {
                    PROCESS_FLAG=false;
                    check+=2;
                  }
                }
              }              
              //System.out.println("("+tmp+")");
            }
            else {
              if( check == 10 ) {
                tmp = s.substring(l,i+1);
                if( tmp.charAt(0) != '#' ) {
                  if( O_HEAD ) {
                    if( vo_head(tmp) ) {
                      check++; PROCESS_FLAG=false;
                      if( i+2 != s.length() ) return false;
                    }
                    else {
                      if( !vi_head(tmp) ) return false;
                      check++; PROCESS_FLAG=false;                      
                    }
                  }
                  else {
                    if( !vi_head(tmp) ) return false;
                    check++; PROCESS_FLAG=false;                    
                  }
                }
                else {
                  if( start_pattern(tmp) ) {
                    check++; 
                    PROCESS_FLAG=false;
                  }
                  else {
                    if( end_pattern(tmp) ) {
                      check++;
                      PROCESS_FLAG=false;
                    }
                  }
                }
                //System.out.println("("+tmp+")");
              }
              else {
                tmp = s.substring(l,i+1);
                if( O_HEAD ) {
                  if( !vo_head(tmp) ) {
                    if( !vi_head(tmp) ) return false;
                    PROCESS_FLAG=false;
                  }
                  else {
                    PROCESS_FLAG=false;
                    //if( i+2 != s.length() ) return false;
                  }
                }
                else {
                  if( !vi_head(tmp) ) return false;
                  PROCESS_FLAG=false;
                }
                //System.out.println("("+tmp+")");
              }
            }
            //System.out.println(s.valueOf(check));
          }
          //  [vo_head] -> if o_head occured or start_pattern or end_pattern or TEACHING_OUTPUT_INCLUDED
          if( check == 12 || check == 13 || check == 14 ) {
            //if( !O_HEAD ) return false;
            if( check == 12 ) {
              PROCESS_FLAG=true;
              tmp =  s.substring(j,i+1);
              l=j;
              if( start_pattern(tmp) ) {
                PROCESS_FLAG = false;
                check+=2;
              }
              else {
                if( end_pattern(tmp) ) {
                  PROCESS_FLAG = false;
                  check+=2;
                }
                else {
                  if( TEACHING_OUTPUT_INCLUDED(s.substring(j,i)) ) {
                    m_TeachingOutputIncluded=true;
                    PROCESS_FLAG = false;
                    check+=2;
                    //System.out.println("("+s.substring(j,i)+")14");
                    if( i+2 != s.length() ) return false;
                    return true;
                  }
                  else {
                    if( !O_HEAD ) return false;
                  }
                }
              }
            }
            else {
              if( check == 13 ) {
                tmp = s.substring(l,i+1);
                if( tmp.charAt(0) != '#' ) {
                  if( !vo_head(tmp) ) return false;
                  PROCESS_FLAG=false;
                  check++;
                  //if( i+2 != s.length() ) return false;
                }
                else {
                  if( start_pattern(tmp) ) {
                    PROCESS_FLAG = false;
                    check++;
                  }
                  else {
                    if( end_pattern(tmp) ) {
                      PROCESS_FLAG = false;
                      check++;
                    }
                    else {
                      if( !O_HEAD ) return false;                      
                    }
                  }                  
                }
              }
              else {
                tmp = s.substring(l,i+1);
                if( !vo_head(tmp) ) return false;
                PROCESS_FLAG=false;
                //if( i+2 != s.length() ) return false;
              }
            }
            //System.out.println(s.valueOf(check));
          }
          // start_pattern or TEACHING_OUTPUT_INCLUDED
          if( check == 15 || check == 16) {
            if( check == 15 ) {
              PROCESS_FLAG=true;
              tmp =  s.substring(j,i+1);
              l=j;
              if( tmp.charAt(0) != '#' ) {
                if( start_pattern(tmp) ) {
                  PROCESS_FLAG = false;
                  check++;
                }
                else {
                  if( !TEACHING_OUTPUT_INCLUDED(s.substring(j,i)) ) return false;
                  m_TeachingOutputIncluded=true;         
                  check++;
                  //System.out.println("("+s.substring(j,i)+") 16");
                  if( i+2 != s.length() ) return false;
                  return true;
                  //System.out.println("err");
                }
              }
            }
            else {
              tmp = s.substring(l,i+1);
              if( !start_pattern(tmp) ) return false;
              PROCESS_FLAG=false;
            }            
          }
          // Endpattern or TEACHING_OUTPUT_INCLUDED
          if( check == 17 || check == 18 ) {            
            if( check == 17 ) {
              PROCESS_FLAG=true;
              tmp =  s.substring(j,i+1);
              l=j;
              if( tmp.charAt(0) != '#' ) {
                if( end_pattern(tmp) ) {
                  PROCESS_FLAG = false;
                  check++;
                }
                else {
                  if( !TEACHING_OUTPUT_INCLUDED(s.substring(j,i)) ) return false;
                  m_TeachingOutputIncluded=true; 
                  check++;
                  //System.out.println("("+s.substring(j,i)+") 18");
                  if( i+2 != s.length() ) return false;
                  return true;
                }
              }
            }
            else {
              tmp = s.substring(l,i+1);
              if( !end_pattern(tmp) ) return false;
              PROCESS_FLAG=false;
            }            
          }
          
          // Teaching Output Included
          if( check == 19 ) {            
            tmp = s.substring(j,i);
            //System.out.println("t("+tmp+")19");
            if( !TEACHING_OUTPUT_INCLUDED(tmp) ) return false;
            m_TeachingOutputIncluded=true;
            if( i+2 != s.length() ) return false;
            return true;
          }
        check++; j=i+1;
        }      
      }
      if( check < 5 ) return false;
      if( PROCESS_FLAG ) return false;    
      //System.out.println("valid");
      return true;
    } catch (StringIndexOutOfBoundsException e1) {
        System.out.println("***StringIndexOutOfBoundsException: " + e1.toString()+ ": " + this.toString());                
    } catch (NullPointerException e2) {
        System.out.println("***NullPointerException: " + e2.toString());
    }                        
    return false;      
  }
  
  /** pattern_file ::= header pattern_list
    * "SNNS pattern definition file V3.2\n
    *  generated at Thu Apr 21 17:59:47 1994 by pnm2pat\n
    *  No. of patterns : 1\n
    *  No. of input units : 1\n
    *  No. of output units : 2\n
    *  No. of variable input dimensions : 2\n
    *  Maximum input dimensions : [ 223 171 ]\n
    *  No. of variable output dimensions : 2\n
    *  Maximum output dimensions : [ 221 169 ]\n
    *  startpattern        : 1\n
    *  endpattern          : 26\n
    *  teaching output included\n

    *  #Pattern 1 (Input)\n
    *  [ 223 171 ]\n
    *  0.717647 0.717647 0.72549 0.717647 0.717647 0.717647 0.717647 \n
    *  0.72549 0.717647 0.717647 0.717647 0.717647 0.717647 0.717647 \n
    *  0.717647 0.72549 0.717647 0.717647 0.717647 0.717647 0.717647 \n
    *  0.717647 0.717647 0.717647 0.717647 0.717647 0.717647 0.717647 \n
    *   ...."
  */
  protected boolean pattern_file(String s)
  throws NullPointerException { 
    if ( s == null || s.length() == 0){       
      throw new NullPointerException("***RemoveEmtyLines: parameter  t.length() == 0 || t == null : " + this.toString());
    }
    try {
      int max_header = 18, min_header = 4;
      int i,j,k;
      int NL_index[] = new int[max_header];      
      String tmp = new String( RemoveEmptyLines(s) );
      
      for( i=0,j=0; j < max_header && i < tmp.length() ; i++) {
        if( tmp.charAt(i) == '\n' ) {
          NL_index[j] = i+1; 
          j++;
        }        
      }
      k=j;
      if( k < min_header ) return false;      
      
      System.out.println("Validating header...");
      for( j=0,i=k-1; i >= min_header-1 && j == 0; i--) {        
        //System.out.println("("+tmp.substring(0,NL_index[i])+")"+tmp.valueOf(i));        
        if( header(tmp.substring(0,NL_index[i])) ) j=i;
      }      
      if( j == 0 ) return false;
      //System.out.println("Header:\n" + tmp.substring(0,NL_index[j]));
      //System.out.println("("+tmp.substring(NL_index[i+1],tmp.length())+")");      
      System.out.println("Validating pattern_list...");
      return pattern_list(tmp.substring(NL_index[i+1],tmp.length()));
      
    } catch (ArrayIndexOutOfBoundsException e0) {
        System.out.println("***ArrayIndexOutOfBoundsException: " + e0.toString()+ ": " + this.toString());
    } catch (StringIndexOutOfBoundsException e1) {
        System.out.println("***StringIndexOutOfBoundsException: " + e1.toString()+ ": " + this.toString());
    } catch (NullPointerException e2) {
        System.out.println("***NullPointerException: " + e2.toString());
    }                        
    return false;      
  }  
  
  //********
}


    //if ( GR.pattern_entry("1.e10") ) System.out.println("\"1.e10\" -> pattern_entry");
    /*   
    if ( GR.pattern_body("123 456 +1.e10 ") ) System.out.println("\"123 456 +1.e10 \" -> pattern_body");
    if ( GR.pattern_body("123 ") ) System.out.println("\"123 \" -> pattern_body");
    if ( !GR.pattern_body("123 4d56 +1.e10 ") ) System.out.println("\"123 4d56 +1.e10 \" ! pattern_body");
    if ( !GR.pattern_body("    ") ) System.out.println("\"    \" ! pattern_body");
    if ( !GR.pattern_body("123") ) System.out.println("\"123\" ! pattern_body");
    //if ( !GR.pattern_body("") ) System.out.println("\"\" ! pattern_body");
    *//*
    if ( GR.actual_dim_rest("12345") ) System.out.println("\"12345\" -> actual_dim_rest");
    if ( GR.actual_dim_rest("12 345") ) System.out.println("\"12 345\" -> actual_dim_rest");
    if ( GR.actual_dim_rest("1 2 3 4 5") ) System.out.println("\"1 2 3 4 5\" -> actual_dim_rest");
    if ( !GR.actual_dim_rest(" 12345") ) System.out.println("\" 12345\" ! actual_dim_rest");
    if ( !GR.actual_dim_rest("12345 ") ) System.out.println("\"12345 \" ! actual_dim_rest");
    if ( !GR.actual_dim_rest("1.2345") ) System.out.println("\"1.2345\" ! actual_dim_rest");
    //if ( !GR.actual_dim_rest("") ) System.out.println("\"\" ! actual_dim_rest");
    *//*
    if ( GR.actual_dim("[ ]") ) System.out.println("\"[ ]\" -> actual_dim");
    if ( GR.actual_dim("[ 1 ]") ) System.out.println("\"[ 1 ]\" -> actual_dim");
    if ( GR.actual_dim("[ 1 2 34 ]") ) System.out.println("\"[ 1 2 34 ]\" -> actual_dim");    
    if ( !GR.actual_dim("[]") ) System.out.println("\"[]\" ! actual_dim");
    if ( !GR.actual_dim("[  ]") ) System.out.println("\"[  ]\" ! actual_dim");
    if ( !GR.actual_dim("[1 ]") ) System.out.println("\"[1 ]\" ! actual_dim");
    if ( !GR.actual_dim("[ 2]") ) System.out.println("\"[ 2]\" ! actual_dim");
    if ( !GR.actual_dim("[1]") ) System.out.println("\"[1]\" ! actual_dim");
    *//*    
    if ( GR.pattern_start("#Pattern 1 (Input)\n") ) System.out.println("\"#Pattern 1 (Input)\\n\" -> pattern_start");    
    if ( GR.pattern_start("#Pattern 1 (Input)\n[ 223 171 ]\n") ) System.out.println("\"#Pattern 1 (Input)\\n[ 223 171 ]\\n\" -> pattern_start");
    if ( GR.pattern_start("[ 223 171 ]\n") ) System.out.println("\"[ 223 171 ]\\n\" -> pattern_start");
    if ( GR.pattern_start("") ) System.out.println("\"\" -> pattern_start");
    if ( GR.pattern_start("#Pattern 1 (Input)\n[ 223 171 ]\n") ) System.out.println("\"#Pattern 1 (Input)\\n[ 223 171 ]\\n\" -> pattern_start");
    if ( !GR.pattern_start("[ 223 171 ]") ) System.out.println("\"[ 223 171 ]\" ! pattern_start");
    */
    
    
    //String tmp =  new String("123\n\n\n  456\n Info\r\n EOL \r");
    //String tmp =  new String("\r\n");
    //tmp=GR.removeEOL(tmp);
    //System.out.println("("+tmp+")");//+tmp.valueOf(tmp.length()));
    /*
    if ( GR.pattern("#Input:\n1 2 3 \n4 5 6 \n") ) System.out.println("\"#Input:\\n1 2 3 \\n4 5 6 \\n\" -> pattern");
    if ( GR.pattern("#Input:\n[ 3 ]\n1 2 3 \n4 5 6 \n") ) System.out.println("\"#Input:\\n[ 3 ]\\n1 2 3 \\n4 5 6 \\n\" -> pattern");
    if ( GR.pattern("[ 3 ]\n1 2 3 \n4 5 6 \n") ) System.out.println("\"[ 3 ]\\n1 2 3 \\n4 5 6 \\n\" -> pattern");
    if ( GR.pattern("1 2 3 \n4 5 6 \n") ) System.out.println("\"1 2 3 \\n4 5 6 \\n\" -> pattern");    
    if ( !GR.pattern("1 2 3 \n4 5 6 ") ) System.out.println("\"1 2 3 \\n4 5 6 \" ! pattern");        
    if ( !GR.pattern("#Input:\n1 2 3 \n4 5 6 ") ) System.out.println("\"#Input:\\n1 2 3 \\n4 5 6 \" ! pattern");
    *//*
    if ( GR.pattern_list("#Input1:\n1 2 3 \n4 5 6 \n#Input2:\n1 2 3 \n4 5 6 \n#Input3:\n1 2 3 \n4 5 6 \n") ) System.out.println("\"#Input1:\\n1 2 3 \\n4 5 6 \\n#Input2:\\n1 2 3 \\n4 5 6 \\n#Input3:\\n1 2 3 \\n4 5 6 \\n\" -> pattern_list");
    if ( GR.pattern_list("#Input1:\n1 2 3 \n") ) System.out.println("\"#Input1:\\n1 2 3 \\n\" -> pattern_list");
    if ( !GR.pattern_list("#Input1:\n") ) System.out.println("\"#Input1:\\n\" ! pattern_list");
    if ( GR.pattern_list("#inp 1:\n1 2 3 4 \n4 3 2 1 \n#out 1\n5 6 7 8 \n#inp 2\n5 6 7 8 \n") ) System.out.println("check");
    *//*
    if( GR.i_head("#COMMENT\nNo. of input units : 1\n") ) System.out.println("\"#COMMENT\\nNo. of input units : 1\\n\" -> i_head");
    if( GR.i_head("No. of input units : 1\n") ) System.out.println("\"No. of input units : 1\\n\" -> i_head");
    if( !GR.i_head("#COMMENTNo. of input units : 1\n") ) System.out.println("\"#COMMENTnNo. of input units : 1\\n\" ! i_head");
    if( !GR.i_head("No. of input units : 1") ) System.out.println("\"No. of input units : 1\" ! i_head");
    if( !GR.i_head("#sdf\nNo. of input units  1\n") ) System.out.println("\"#sdf\\nNo. of input units  1\\n\" ! i_head"); 
    *//*    
    if( GR.vi_head("#comment\nNo. of variable input dimensions : 1\nMaximum input dimensions : [ 223 171 ]\n")) System.out.println("\"#comment\\nNo. of variable input dimensions : 1\\nMaximum input dimensions : [ 223 171 ]\\n\" -> vi_head");
    if( GR.vi_head("No. of variable input dimensions : 1\nMaximum input dimensions : [ 223 171 ]\n")) System.out.println("\"No. of variable input dimensions : 1\\nMaximum input dimensions : [ 223 171 ]\\n\" -> vi_head");
    if( !GR.vi_head("#comment\nNo. of variable input dimensions : 1\n")) System.out.println("\"#comment\\nNo. of variable input dimensions : 1\\n\" ! vi_head");
    if( !GR.vi_head("#comment\nMaximum input dimensions : [ 223 171 ]\n")) System.out.println("\"#comment\\nnMaximum input dimensions : [ 223 171 ]\\n\" ! vi_head");
    */
    
    //if( GR.header("SNNS pattern definition file V3.2\ngenerated at Thu Apr 21 17:59:47 1994 by pnm2pat\nNo. of patterns : 1\n#input commentar\nNo. of input units : 1\n#output commentar\nNo. of output units : 2\n#vi_head\nNo. of variable input dimensions : 2\nMaximum input dimensions : [ 223 171 ]\n#vo_head\nNo. of variable output dimensions : 2\nMaximum output dimensions : [ 221 169 ]\n") ) System.out.println("Header");
    //if( GR.header("SNNS pattern definition file V3.2\ngenerated at Thu Apr 21 17:59:47 1994 by pnm2pat\nNo. of patterns : 1\n#input commentar\nNo. of input units : 1\n#vi_head\nNo. of variable input dimensions : 2\nMaximum input dimensions : [ 223 171 ]\n") ) System.out.println("Header");
    
    //String tmp = new String(GR.RemoveEmptyLines("\n\n\n\n\r00\r 12\r\r34\n5 35\r 9353\n\n"));
    //System.out.println("("+tmp+")");    
    //GR.removeEOL("");
    //GR.pattern_file("SNNS pattern definition file V3.2\ngenerated at Thu Apr 21 17:59:47 1994 by pnm2pat\nNo. of patterns : 1\n#sdf\nNo. of input units : 1\n#sdf\nNo. of output units : 2\n#sdf\nNo. of variable input dimensions : 2\nMaximum input dimensions : [ 223 171 ]\n#sdf\nNo. of variable output dimensions : 2\nMaximum output dimensions : [ 221 169 ]\n#sdf\n#sdf\n#sdf\n");  