/*
 * IConfigurationWriter.java
 *
 * Created on 8. Mai 2000, 09:02
 */
 
package YARB.Interfaces;

/** 
 * This interface provides functionality for writing configuration to a file
 * @author  Thomas
 * @version 
 */
public interface IConfigurationWriter 
{

  /**
  * Creates a new tree node with the given name and opens it.
  */
  void CreateNode(String NodeName)  throws ECfgWriterError;
  
  /**
  * Closes the last actual tree node
  */
  void CloseNode(String NodeName) throws ECfgWriterError;
  
  /**
  * Save the class name of the caller
  */
  void  addClass(String value) throws ECfgWriterError;
  /**
  * Save the title of the caller
  */
  void  addTitle(String value) throws ECfgWriterError;
  /**
  * Save the Filesource filename
  */
  void  addFile(String value) throws ECfgWriterError;
  /**
  * Writes a boolean value that has the given name.
  */
  void   addBoolean(boolean value) throws ECfgWriterError;
  
  /**
  * Writes a integer value that has the given name.
  */
  void   addInt(int value) throws ECfgWriterError;
  
  /**
  * Writes a float value that has the given name.
  */
  void   addfloat(float value) throws ECfgWriterError;
    
  /**
  * Writes a string value that has the given name.
  */
  void   addString(String value) throws ECfgWriterError;
  
 
  //***
  //*** Deklaration of the exception classes:
  //***
  class ECfgWriterError extends Exception
  {
    public ECfgWriterError(String description)
    {
      super(description);
    }
  }
  
}
