/*
 * IDataHolder.java
 *
 * Created on 1. Mai 2000, 15:37
 */
 
package YARB.Interfaces;

/** 
 * This is the interface declaration for a data holder.
 * A data holder does nothing than copying the data from the given data provider
 * to an internal buffer and provides it for further purposes (mostly for displaying data)
 * @author  Thomas
 * @version 
 */
public interface IDataHolder
extends IDataRepresentation
{
  /**
  * Sets the data provider.
  * This function copies all the data from the given data provider into 
  * its own buffer. It does NOT call the ProcessData and FreeData functions of the provider!
  */
  void setData(IDataProvider DP) throws IDataProvider.DataProcessingError;
}
