/*
 * IDataRepresentation.java
 *
 * Created on 1. Mai 2000, 16:01
 */
 
package YARB.Interfaces;

/** 
 * The IDataRepresentation is the abstract data description for visualization data.
 * This data format is leand on the SNNS pattern data format.
 * @author  Thomas
 * @version 
 */
public interface IDataRepresentation 
{

  /**
  * Gets the number of pattern.
  */
  int numbOfPatterns();
  
  /**
  * Gets the number of input units.
  */
  int numbOfInputUnits();
  
  /**
  * Gets the number of Output Units
  */
  int numbOfOutputUnits();
  
  /**
  * Gets the number of variable Input dimensions
  */
  int numbOfVariableInputDimensions();
  
  /**
  * Gets the number of variable Output dimensions
  */
  int numbOfVariableOutputDimensions();
  
  /**
  * Gets the maximum input dimensions range for the given variable input dimension
  */
  int getMaxInputDimesion(int nVarInputDimension);
  
  /**
  * Gets the maximum output dimensions range for the given variable output dimension
  */
  int getMaxOutputDimesion(int nVarOutputDimension);
  
  /**
  * Gets a input data field, inthe given pattern and specified by the give unit.
  */
  float getInputData(int nPattern, int nUnit);

  /**
  * Gets a output data field, inthe given pattern and specified by the give unit.
  */
  float getOutputData(int nPattern, int nUnit);
  
}
