/*
 * YClassChooser.java
 *
 * Created on 24. Mai 2000, 08:55
 */
 
package YARB.Dialogs;
import java.util.Vector;
import java.awt.Point;
import java.awt.Dimension;

/** 
 *
 * @author  Thomas
 * @version 
 */
public class YClassChooser extends javax.swing.JDialog {

  String [][] m_Classes;
  boolean     m_bUserClass;
  boolean     m_bOK;
  
  
  /** Creates new form YClassChooser */
  public YClassChooser(java.awt.Frame parent,String strTitle,boolean modal) {
    super (parent, strTitle,modal);
    initComponents ();
    pack ();
    
    UserClassChanged(true);
    m_bOK=false;
    
   // Center on the parent frame on the screen    
    if(parent != null)
    {
       Dimension screenSize =parent.getSize();
       Dimension size = getSize();
       Point parentPos = parent.getLocation();
       screenSize.height = screenSize.height/2;
       screenSize.width = screenSize.width/2;
       size.height = size.height/2;
       size.width = size.width/2;
       int y = screenSize.height - size.height + parentPos.y;
       int x = screenSize.width - size.width + parentPos.x;
       setLocation(x, y);        
    };    
  }

  public void setClasses(String [][] a){
    
    Vector v = new Vector();
    String str;
    
    for (int i=0; i<a.length; ++i) 
    {
      if(a[i].length>=3) {
        str= a[i][1] + ": " + a[i][2] +" [" + a[i][0] + "]";
        v.add(i,str);
      };
    };
    
    listClasses.setListData(v);
    m_Classes=a;
  }
  
  
  public void setInterface(String i){
    labelInterface.setText(i);
  }
  
  public String getSelectedClass(){
    
    String str=null;

    if(!m_bOK) return null;  // User cancel?
    
    if(m_bUserClass)  // a list class selected?
    {
      if(!listClasses.isSelectionEmpty() && m_Classes!=null)
      {
        str=m_Classes[listClasses.getSelectedIndex()][0];
      };
    }
    else
    {
      str=textExternal.getText();
    }

    return str;
  }
  
  
  private void UserClassChanged(boolean state){
   radioInternal.setSelected(state);
   radioExternal.setSelected(!state);
    m_bUserClass=state;
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    jLabel1 = new javax.swing.JLabel ();
    radioInternal = new javax.swing.JRadioButton ();
    textExternal = new javax.swing.JTextField ();
    labelNote = new javax.swing.JLabel ();
    labelInterface = new javax.swing.JLabel ();
    jScrollPane1 = new javax.swing.JScrollPane ();
    listClasses = new javax.swing.JList ();
    radioExternal = new javax.swing.JRadioButton ();
    buttonOK = new javax.swing.JButton ();
    buttonCancel = new javax.swing.JButton ();
    getContentPane ().setLayout (new java.awt.GridBagLayout ());
    java.awt.GridBagConstraints gridBagConstraints1;
    addWindowListener (new java.awt.event.WindowAdapter () {
      public void windowClosing (java.awt.event.WindowEvent evt) {
        closeDialog (evt);
      }
    }
    );

    jLabel1.setText ("Please choose the class to load:");
    jLabel1.setForeground (java.awt.Color.blue);


    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridx = 0;
    gridBagConstraints1.gridy = 0;
    gridBagConstraints1.gridwidth = 2;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
    gridBagConstraints1.insets = new java.awt.Insets (10, 10, 0, 0);
    getContentPane ().add (jLabel1, gridBagConstraints1);

    radioInternal.setText ("YARB provided class:");
    radioInternal.addActionListener (new java.awt.event.ActionListener () {
      public void actionPerformed (java.awt.event.ActionEvent evt) {
        radioInternalActionPerformed (evt);
      }
    }
    );


    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridx = 0;
    gridBagConstraints1.gridy = 1;
    gridBagConstraints1.gridwidth = 3;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
    gridBagConstraints1.insets = new java.awt.Insets (14, 40, 0, 0);
    getContentPane ().add (radioInternal, gridBagConstraints1);



    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridx = 0;
    gridBagConstraints1.gridy = 4;
    gridBagConstraints1.gridwidth = 8;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
    gridBagConstraints1.ipadx = 356;
    gridBagConstraints1.ipady = 10;
    gridBagConstraints1.insets = new java.awt.Insets (6, 40, 0, 0);
    getContentPane ().add (textExternal, gridBagConstraints1);

    labelNote.setText ("NOTE: Required Interface:");


    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridx = 0;
    gridBagConstraints1.gridy = 5;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
    gridBagConstraints1.insets = new java.awt.Insets (0, 40, 0, 0);
    getContentPane ().add (labelNote, gridBagConstraints1);

    labelInterface.setText ("YARB.Interfaces.IConfigurable");
    labelInterface.setFont (new java.awt.Font ("Dialog", 2, 11));


    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridx = 5;
    gridBagConstraints1.gridy = 5;
    gridBagConstraints1.gridwidth = 2;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
    gridBagConstraints1.insets = new java.awt.Insets (0, 30, 0, 0);
    getContentPane ().add (labelInterface, gridBagConstraints1);


      listClasses.setSelectionMode (javax.swing.ListSelectionModel.SINGLE_SELECTION);
  
      jScrollPane1.setViewportView (listClasses);
  

    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridx = 0;
    gridBagConstraints1.gridy = 2;
    gridBagConstraints1.gridwidth = 8;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
    gridBagConstraints1.ipadx = 342;
    gridBagConstraints1.ipady = 72;
    gridBagConstraints1.insets = new java.awt.Insets (6, 40, 0, 0);
    getContentPane ().add (jScrollPane1, gridBagConstraints1);

    radioExternal.setText ("External class (full qualifier):");
    radioExternal.addActionListener (new java.awt.event.ActionListener () {
      public void actionPerformed (java.awt.event.ActionEvent evt) {
        radioExternalActionPerformed (evt);
      }
    }
    );


    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridx = 0;
    gridBagConstraints1.gridy = 3;
    gridBagConstraints1.gridwidth = 4;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
    gridBagConstraints1.insets = new java.awt.Insets (10, 30, 0, 0);
    getContentPane ().add (radioExternal, gridBagConstraints1);

    buttonOK.setText ("OK");
    buttonOK.addActionListener (new java.awt.event.ActionListener () {
      public void actionPerformed (java.awt.event.ActionEvent evt) {
        buttonOKActionPerformed (evt);
      }
    }
    );


    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridx = 0;
    gridBagConstraints1.gridy = 7;
    gridBagConstraints1.gridwidth = 5;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
    gridBagConstraints1.ipadx = 31;
    gridBagConstraints1.ipady = 3;
    gridBagConstraints1.insets = new java.awt.Insets (14, 120, 0, 0);
    getContentPane ().add (buttonOK, gridBagConstraints1);

    buttonCancel.setText ("Cancel");
    buttonCancel.addActionListener (new java.awt.event.ActionListener () {
      public void actionPerformed (java.awt.event.ActionEvent evt) {
        buttonCancelActionPerformed (evt);
      }
    }
    );


    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridx = 5;
    gridBagConstraints1.gridy = 7;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
    gridBagConstraints1.ipadx = 13;
    gridBagConstraints1.ipady = 3;
    gridBagConstraints1.insets = new java.awt.Insets (14, 30, 0, 0);
    getContentPane ().add (buttonCancel, gridBagConstraints1);

  }//GEN-END:initComponents

  private void buttonCancelActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCancelActionPerformed
// Add your handling code here:
    m_bOK=false;
    setVisible (false);
    dispose ();
    
  }//GEN-LAST:event_buttonCancelActionPerformed

  private void buttonOKActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonOKActionPerformed
// Add your handling code here:
    m_bOK=true;
    setVisible (false);
    dispose ();

  }//GEN-LAST:event_buttonOKActionPerformed

  private void radioExternalActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioExternalActionPerformed
// Add your handling code here:
    UserClassChanged(false);
  }//GEN-LAST:event_radioExternalActionPerformed

  private void radioInternalActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioInternalActionPerformed
// Add your handling code here:
    UserClassChanged(true);
  }//GEN-LAST:event_radioInternalActionPerformed

  /** Closes the dialog */
  private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
    setVisible (false);
    dispose ();
  }//GEN-LAST:event_closeDialog

 

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel jLabel1;
  private javax.swing.JRadioButton radioInternal;
  private javax.swing.JTextField textExternal;
  private javax.swing.JLabel labelNote;
  private javax.swing.JLabel labelInterface;
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JList listClasses;
  private javax.swing.JRadioButton radioExternal;
  private javax.swing.JButton buttonOK;
  private javax.swing.JButton buttonCancel;
  // End of variables declaration//GEN-END:variables

}