/*
 * YDFOne2One.java
 *
 * Created on 17. April 2000, 22:18
 */
 
package YARB.Filter;
import YARB.Interfaces.*;
import javax.swing.*;
import YARB.Dialogs.*;


/** 
 *
 * @author  Thomas
 * @version 
 */
public class YDFOne2One 
extends Object 
implements IDataFilter
{

  /** Creates new YDFOne2One */
  public YDFOne2One() 
  {
  }

  protected IDataProvider m_PrevProv;
  
  public void setPreviousProvider(IDataProvider DP) 
  {
    m_PrevProv=DP;
  }
  
  public int numbOfPatterns() 
  {
    return m_PrevProv.numbOfPatterns();
  }
  
  public int numbOfInputUnits() 
  {
    return m_PrevProv.numbOfInputUnits();
  }
  
  public int numbOfOutputUnits() 
  {
    return m_PrevProv.numbOfOutputUnits();
  }

  public int numbOfVariableInputDimensions()
  {
    return m_PrevProv.numbOfVariableInputDimensions();
  }
  
  public int numbOfVariableOutputDimensions()
  {
    return m_PrevProv.numbOfVariableOutputDimensions();
  }
  
  public int getMaxInputDimesion(int nVarInputDimension)
  {
    return m_PrevProv.getMaxInputDimesion(nVarInputDimension);
  }
  
  public int getMaxOutputDimesion(int nVarOutputDimension)
  {
    return m_PrevProv.getMaxOutputDimesion(nVarOutputDimension);
  }
  
  public float getInputData(int nPattern,int nUnit) 
  {
    return m_PrevProv.getInputData(nPattern,nUnit);
  }
  
  public float getOutputData(int nPattern,int nUnit) 
  {
    return m_PrevProv.getOutputData(nPattern, nUnit);
  }
  
  public boolean ProcessData() throws IDataProvider.DataProcessingError
  {
    return m_PrevProv.ProcessData();
  }
  
  public boolean FreeData() 
  {
    return m_PrevProv.FreeData();
  }
  
  /** This function forces the object to save its configuration data to a file
   */
  public boolean SaveConfiguration(IConfigurationWriter Cfg) throws IConfigurationWriter.ECfgWriterError {
    if(Cfg==null) return false;
    
    Cfg.addTitle(getName());
    
    return true;
  }
  
  /** This function forces the object to read a configuration from a file
   */
  public boolean LoadConfiguration(IConfigurationReader Cfg) throws IConfigurationReader.ECfgReaderError {
    if(Cfg==null) return false;
    
    setName(Cfg.getTitle());
    return true;
  }  
  public boolean IsConfigurable() 
  {
    return true;
  }
  
  public boolean ShowConfigurationDialog(JFrame ParentFrame) 
  {
   YStandardNameChooser dlg;
   dlg= new YStandardNameChooser(ParentFrame, "YARB Filter Properties",true,getName());
   dlg.show();
   setName(dlg.getName());

   return true;
  }
  
  /**
  * Contains the assigned name string.
  */
  private String  m_strName;
  
  /**
  * Assigns a name to the current object.
  */
  public void setName(String strName){
    m_strName=strName;
  }
    
  /**
  * Returns the assigned name of the object
  */
  public String  getName(){
    return m_strName;
  }
  
}