/*
 * YDVAgentFrame.java
 *
 * Created on 17. Mai 2000, 20:04
 */
package YARB.Viewer.SpecialViewer;
import YARB.Interfaces.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.Graphics2D;

/**
 *
 * @author  Erich
 * @version
 */
public class YDVAgentFrame extends javax.swing.JInternalFrame {

  private IDataHolder m_data;         // Holds the data
  private int m_nCurrentPattern;      // The number of the currently selected pattern
  private boolean m_bCurrentIsInput;  // Is the currently selected pattern an input pattern?
  ImagePanel imgP = new ImagePanel();
  Image m_Left,m_Right,m_Up,m_Down;

  public YDVAgentFrame(String strTitle){
    super(strTitle,
    true, //resizable
    true, //closable
    true, //maximizable
    true

    );//iconifiable


    initComponents();
    scrollPane.setViewportView( imgP);
    setSize(500,500);
    m_Left= getToolkit().getImage(getClass().getResource("/YARB/images/AgentExample/Left.gif"));
    m_Right = getToolkit().getImage(getClass().getResource("/YARB/images/AgentExample/Rigth.gif"));
    m_Up    = getToolkit().getImage(getClass().getResource("/YARB/images/AgentExample/Up.gif"));
    m_Down  = getToolkit().getImage(getClass().getResource("/YARB/images/AgentExample/Down.gif"));
  
    m_data=null;
  }

  
  
  private void initComponents () {//GEN-BEGIN:initComponents
    scrollPane = new javax.swing.JScrollPane ();
    getContentPane ().setLayout (new java.awt.BorderLayout ());
    setDoubleBuffered (true);
    setBackground (java.awt.Color.white);
    setDebugGraphicsOptions (javax.swing.DebugGraphics.NONE_OPTION);
    setForeground (java.awt.Color.white);

    scrollPane.setDoubleBuffered (true);
    scrollPane.setOpaque (true);
    scrollPane.setBackground (java.awt.Color.white);
    scrollPane.setDebugGraphicsOptions (javax.swing.DebugGraphics.NONE_OPTION);


    getContentPane ().add (scrollPane, java.awt.BorderLayout.CENTER);

  }//GEN-END:initComponents


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JScrollPane scrollPane;
  // End of variables declaration//GEN-END:variables
 
  public void setDataHolder(IDataHolder data){
    m_data=data;
  }

  class ImagePanel extends javax.swing.JPanel{

    public ImagePanel() {    
         // this.image = image;
      super();    
           setSize(301,301);

      }

  
 
    public void paint(Graphics g)
    {
      super.paint(g);
      Graphics2D g2 = (Graphics2D) g;
      Dimension d = getSize();
      
      g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
    
      if(m_data==null) return;  // uups. no data? fuck!
      
   
      int XAxis   =  d.width /2;   
      int YAxis   =  d.height /2;   
    
      
      if(m_data.numbOfInputUnits() < 2) {
        System.out.println("Number of Inputunits too small: Minimum 2!");
        return;
      }
      if(m_data.numbOfOutputUnits() < 1) {
        System.out.println("Number of Outputunits too small: Minimum 1!");
        return;
      }
 
      
    g2.drawLine(30, YAxis, d.width-30, YAxis);        // Axes
    g2.drawLine(XAxis, d.height - 30 , XAxis, 30);
   
    g2.drawLine( d.width-30, YAxis,  d.width-30-8, YAxis-5);  // Axes-Arrows
    g2.drawLine( d.width-30, YAxis,  d.width -30-8, YAxis+5);
    
    g2.drawLine( XAxis, 30,  XAxis-5, 30+8);
    g2.drawLine( XAxis, 30,  XAxis+5, 30+8);
    
    g2.drawString("x", XAxis+10, 30);
    g2.drawString("y", d.width-30 ,YAxis+ 10);
    
   
    
// drawing the input output values
      
      float MaximumX=0;
      float MaximumY=0;
      int PercentageX = XAxis-50;
      int PercentageY = YAxis-50;
      int x,y;
      
      
      for(int i=0; i < m_data.numbOfPatterns(); i++){
       
        // hier wenn ntig Axenbeschriftung - Skalierung
        
          if  (Math.abs(m_data.getInputData(i,0)) >= MaximumX)
            { MaximumX = Math.abs(m_data.getInputData(i,0));}
          if  (Math.abs(m_data.getInputData(i,1)) >= MaximumY)
            { MaximumY = Math.abs(m_data.getInputData(i,1));}  
    
      };
     

     float pic;
    
     for(int i=0; i < m_data.numbOfPatterns(); i++){
        
        
        x = (int) (m_data.getInputData(i,0)*PercentageX / MaximumX);
        y = (int) (m_data.getInputData(i,1)*PercentageY / MaximumY);
        
        
        pic = m_data.getOutputData(i,0); 
        if ( pic > -0.5 && pic < 0.5)
         {
          g2.drawImage(m_Left, XAxis+x ,YAxis+y,this);
         }
        else if ( pic > 0.5 && pic < 1.5)
         {
          g2.drawImage(m_Up, XAxis+x ,YAxis+y,this);
         }
        else if ( pic > 1.5 && pic < 2.5)
         {
          g2.drawImage(m_Right, XAxis+x ,YAxis+y,this);
         }
        else if ( pic > 2.5 && pic < 3.5)
         {
          g2.drawImage(m_Down, XAxis+x ,YAxis+y,this);
         }
    
       };     
 
    }

  }

}
