/*
 * YDVImgClassFrame.java
 *
 * Created on 6. June 2000, 15:28
 */
 
package YARB.Viewer.SpecialViewer;
import YARB.Interfaces.*;
import java.awt.*;
import javax.swing.*;
import java.util.Vector;


/** 
 *
 * @author  Erich
 * @version 
 */
public class YDVImgClassFrame extends javax.swing.JInternalFrame {

  /** Creates new form YDVPlainTextFrame */
/*  public YDVPlainTextFrame() {
    initComponents ();
    m_data=null;
  }
*/  

  private IDataHolder m_data;         // Holds the data
  private int m_nCurrentPattern;      // The number of the currently selected pattern
  private boolean m_bCurrentIsInput;  // Is the currently selected pattern an input pattern?
  private Vector  m_vListData;        // Holds the List data

  
  public YDVImgClassFrame(String strTitle){
    super(strTitle,
                true, //resizable
                true, //closable
                true, //maximizable
                true);//iconifiable
    
    
    initComponents();
        
    setSize(500,500);
    splitPane.setDividerLocation(120);

    m_data=null;
    m_nCurrentPattern=0;
    m_bCurrentIsInput=true;
    m_vListData=null;
  }
 

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    splitPane = new javax.swing.JSplitPane ();
    patternList = new javax.swing.JList ();
    patternPane = new javax.swing.JScrollPane ();
    getContentPane ().setLayout (new java.awt.BorderLayout ());

    splitPane.setDoubleBuffered (true);
    splitPane.setBackground (java.awt.Color.white);
    splitPane.setOneTouchExpandable (true);

      patternList.setDoubleBuffered (true);
      patternList.addListSelectionListener (new javax.swing.event.ListSelectionListener () {
        public void valueChanged (javax.swing.event.ListSelectionEvent evt) {
          patternListValueChanged (evt);
        }
      }
      );
  
      splitPane.setLeftComponent (patternList);
  
      patternPane.setDoubleBuffered (true);
      patternPane.setOpaque (true);
      patternPane.setBackground (java.awt.Color.white);
  
      splitPane.setRightComponent (patternPane);
  

    getContentPane ().add (splitPane, java.awt.BorderLayout.CENTER);

  }//GEN-END:initComponents

  
  private void patternListValueChanged (javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_patternListValueChanged
// Add your handling code here:
        if (evt.getValueIsAdjusting())
            return;

        JList theList = (JList)evt.getSource();
        if (theList.isSelectionEmpty()) {
            m_nCurrentPattern=0;
            m_bCurrentIsInput=true;
        } else {
            int index = theList.getSelectedIndex();
            if(m_vListData==null) return;
            
            ListElement e= (ListElement)m_vListData.get(index);
            m_nCurrentPattern=e.getPattern();
            m_bCurrentIsInput=e.isInput();
        }    
        
        // Call the java-swion repaint method (NOT my Repaint!)
        
        repaint();
        
  }//GEN-LAST:event_patternListValueChanged


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JSplitPane splitPane;
  private javax.swing.JList patternList;
  private javax.swing.JScrollPane patternPane;
  // End of variables declaration//GEN-END:variables

  public void setDataHolder(IDataHolder data){
    m_data=data;
    Repaint();
  }

  /** Repaints the frame cause the data has changed
  *   NOTE: This method is user-defined and has nothing
  *   to do with the Java-Swing "repaint"-method!!!
  */  
  public void Repaint()
  {
    if(m_data==null) return;  // uups. no data? fuck!

    // Do your On-Data-Change things.

    //** Create the pattern List:
    m_vListData= new Vector();
    
    for(int i=0; i<m_data.numbOfPatterns();i++)
    {
      if (m_data.numbOfInputUnits()>0){
        m_vListData.add(new ListElement(i,true,">> Input pattern " + i));
      };
      if (m_data.numbOfOutputUnits()>0){
        m_vListData.add(new ListElement(i,false,"<< Output pattern " + i));
      };
    };
    // Set the new pattern list:
    patternList.setListData(m_vListData);
  }
  
  /** 
  *  This function gives the number of the curently selected pattern in the pattern list
  */
  public int getCurrentPattern(){
    return m_nCurrentPattern;
  }
  
  /**
  * This function says whether the currently selected pattern in the pattern list is an input pattern.
  * Returns true if it is an input pattern or false if it is a output pattern.
  */
  public boolean getCurrentIsInput(){
    return m_bCurrentIsInput;
  }

  /**
  * Returns the paint area's upper left corner.
  */
  private Point getUpperLeftPaintCorner(){
    return new Point(splitPane.getDividerLocation()+splitPane.getDividerSize(),getInsets().top*3);
  }
    
  
  /** Overloading of the Java-Swing paint method for user drawn graphics.
  *   Here the 2D graphics will be painted.
  *   This function is called by the java framework every time when the
  *   frame has to be repainted.
  */
 

  /**
  *  ListElement is a container class of information for each list element.
  */
  private class ListElement extends Object
  {
    private int m_nPattern;
    private boolean m_bInput;
    private String m_strTitle;
    
    ListElement(int nPattern,boolean bInput, String strTitle)
    {
      m_nPattern=nPattern;
      m_bInput=bInput;
      m_strTitle=strTitle;
    }
    
      public String toString() {
      return m_strTitle;
    }
    
    int getPattern(){
      return m_nPattern;
    }
    
    boolean isInput(){
      return m_bInput;
    }
  }

  
  
  
  
  public void paint(Graphics g)
  {
    // NOTE: Don't forget to let the frame painted by your base class first!
    super.paint(g);   

    Graphics2D g2 = (Graphics2D) g;
    g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
    Dimension d = getSize();
    
    if(m_data==null) return;  // uups. no data? fuck!
        
    Point start=getUpperLeftPaintCorner();
    int StartOvalX  =  start.x + 100;   
    int StartOvalY  =  start.y + 100;  
    int OvalWidth   =  (d.width - 100) - StartOvalX;
    int OvalHeight  =  (d.height - 100) - StartOvalY;      
  
  
  
    
    
    // drawing the input output values
   
    if(getCurrentIsInput())   // Is an input pattern selected?
    {
      g2.drawString("InputPattern " + getCurrentPattern() + " - selected", d.width / 2, d.height - 20);
      g2.drawOval(StartOvalX1, StartOvalY1, Radius*2, Radius*2);
      g2.drawLine(OvalCenterX, OvalCenterY, OvalCenterX + Radius, OvalCenterY);
      
      // evaluate maximum value of pattern in/output
      for(int i=0; i < m_data.numbOfInputUnits(); i++)
      { 
        percentage = percentage +  Math.abs(m_data.getInputData(getCurrentPattern(),i)); 
        
      }
     
    
      for(int i=0; i < m_data.numbOfInputUnits(); i++)     
      { 
        angle = angle + (( Math.abs(m_data.getInputData(getCurrentPattern(),i)) * 360) / percentage)* Math.PI / 180;
      
        g2.setPaint(red);
        
        g2.drawLine(OvalCenterX, OvalCenterY, 
                (int) (OvalCenterX + Radius * Math.cos(angle)), 
                (int) (OvalCenterY - Radius * Math.sin(angle)));
           
      }       
    }
    
    
    else                      // A output pattern is selected.
    {      
      g2.drawString("OutputPattern " + getCurrentPattern() + " - selected", d.width / 2, d.height - 20);
      g2.drawOval(StartOvalX1, StartOvalY1, Radius*2, Radius*2);
      g2.drawLine(OvalCenterX, OvalCenterY, OvalCenterX+ Radius, OvalCenterY);
      
      // evaluate maximum value of pattern in/output
      for(int i=0; i < m_data.numbOfOutputUnits(); i++)
      { 
        percentage = percentage +  Math.abs(m_data.getOutputData(getCurrentPattern(),i)); 
        
      }
     
    
      for(int i=0; i < m_data.numbOfOutputUnits(); i++)     
      { 
        angle = angle + (( Math.abs(m_data.getOutputData(getCurrentPattern(),i)) * 360) / percentage)* Math.PI / 180;
      
        g2.setPaint(red);
        
        g2.drawLine(OvalCenterX, OvalCenterY, 
                (int) (OvalCenterX + Radius * Math.cos(angle)), 
                (int) (OvalCenterY - Radius * Math.sin(angle)));  
     
      }
    }
  }
}