/*
 * MainFrame.java
 *
 * Created on 18. April 2000, 17:08
 */
 
package YARB.Main;
import YARB.Main.*;
import YARB.Interfaces.*;
import javax.swing.*;
import YARB.Html.*;
import java.net.URL;
import java.awt.*;


/** 
 *
 * @author  Thomas
 * @version 
 */
public class YMainFrame extends javax.swing.JFrame
implements IMainFrame
{

  
  /** Creates new form MainFrame */
/*  public YMainFrame() {
    initComponents ();
    pack ();
  }
*/  
  public YMainFrame(String title)
  {
    super(title);
    
    initComponents();
    
   //Make the big window be indented 50 pixels from each edge 
   //of the screen.
   int inset = 50;
   Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
   setBounds(inset, inset, 
             screenSize.width - inset*2, 
             screenSize.height-inset*2);
    
  
   //Make dragging faster:
   desktopPane.putClientProperty("JDesktopPane.dragMode", "outline");

   // let the director know that we are here
    YGlobalNavigationDirector dir = YGlobalNavigationDirector.exemplar();
    dir.setMainFrame(this);
    
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    menuBar = new javax.swing.JMenuBar ();
    fileMenu = new javax.swing.JMenu ();
    NewVisualizationMenuItem = new javax.swing.JMenuItem ();
    RedoVisualizationMenuItem = new javax.swing.JMenuItem ();
    jSeparator3 = new javax.swing.JSeparator ();
    OpenCfgMenuItem = new javax.swing.JMenuItem ();
    SaveCfgMenuItem = new javax.swing.JMenuItem ();
    jSeparator4 = new javax.swing.JSeparator ();
    exitMenuItem = new javax.swing.JMenuItem ();
    editMenu = new javax.swing.JMenu ();
    cutMenuItem = new javax.swing.JMenuItem ();
    copyMenuItem = new javax.swing.JMenuItem ();
    pasteMenuItem = new javax.swing.JMenuItem ();
    deleteMenuItem = new javax.swing.JMenuItem ();
    ConfigurationMenu = new javax.swing.JMenu ();
    compNewMenu = new javax.swing.JMenu ();
    compNewContainerMenuItem = new javax.swing.JMenuItem ();
    compNewFileSourceMenuItem = new javax.swing.JMenuItem ();
    compNewFilterMenuItem = new javax.swing.JMenuItem ();
    compNewViewMenuItem = new javax.swing.JMenuItem ();
    compDelMenuItem = new javax.swing.JMenuItem ();
    jSeparator1 = new javax.swing.JSeparator ();
    compConfigureMenuItem = new javax.swing.JMenuItem ();
    jSeparator2 = new javax.swing.JSeparator ();
    compUpMenuItem = new javax.swing.JMenuItem ();
    compDownMenuItem = new javax.swing.JMenuItem ();
    helpMenu = new javax.swing.JMenu ();
    contentMenuItem = new javax.swing.JMenuItem ();
    aboutMenuItem = new javax.swing.JMenuItem ();
    cfgToolBar = new javax.swing.JToolBar ();
    NewVisualizationToolButton = new javax.swing.JButton ();
    RedoVisualizationToolButton = new javax.swing.JButton ();
    OpenConfigurationToolButton = new javax.swing.JButton ();
    SaveConfigurationToolButton = new javax.swing.JButton ();
    cfgNewConfigurationToolButton = new javax.swing.JButton ();
    cfgNewFileSourceToolButton = new javax.swing.JButton ();
    cfgNewFilterToolButton = new javax.swing.JButton ();
    cfgNewViewToolButton = new javax.swing.JButton ();
    cfgDeleteToolButton = new javax.swing.JButton ();
    cfgConfigureToolButton = new javax.swing.JButton ();
    cfgUpToolButton = new javax.swing.JButton ();
    cfgDownToolButton = new javax.swing.JButton ();
    AboutToolButton = new javax.swing.JButton ();
    HelpToolButton = new javax.swing.JButton ();
    scrollPane = new javax.swing.JScrollPane ();
    desktopPane = new javax.swing.JDesktopPane ();

      fileMenu.setText ("File");
  
        NewVisualizationMenuItem.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/NewVisualization.gif")));
        NewVisualizationMenuItem.setToolTipText ("Creates a new visualization from the selected configuration with a new file.");
        NewVisualizationMenuItem.setText ("New visualization...");
        NewVisualizationMenuItem.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            NewVisualizationMenuItemActionPerformed (evt);
          }
        }
        );
    
        fileMenu.add (NewVisualizationMenuItem);
        RedoVisualizationMenuItem.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/CurrentVisualization.gif")));
        RedoVisualizationMenuItem.setToolTipText ("Creates a new visualization from the selected configuration with the current file.");
        RedoVisualizationMenuItem.setText ("Redo visualization");
        RedoVisualizationMenuItem.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            CurrentVisualizationMenuItemActionPerformed (evt);
          }
        }
        );
    
        fileMenu.add (RedoVisualizationMenuItem);
    
        fileMenu.add (jSeparator3);
        OpenCfgMenuItem.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/OpenConfiguration.gif")));
        OpenCfgMenuItem.setToolTipText ("Opens a configuration from a file.");
        OpenCfgMenuItem.setText ("Open configuration...");
        OpenCfgMenuItem.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            OpenCfgMenuItemActionPerformed (evt);
          }
        }
        );
    
        fileMenu.add (OpenCfgMenuItem);
        SaveCfgMenuItem.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/SaveConfiguration.gif")));
        SaveCfgMenuItem.setToolTipText ("Saves the selected configuration to a file.");
        SaveCfgMenuItem.setText ("Save configuration...");
        SaveCfgMenuItem.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            SaveAsMenuItemActionPerformed (evt);
          }
        }
        );
    
        fileMenu.add (SaveCfgMenuItem);
    
        fileMenu.add (jSeparator4);
        exitMenuItem.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/Exit.gif")));
        exitMenuItem.setToolTipText ("Closes YARB.");
        exitMenuItem.setText ("Exit");
        exitMenuItem.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            exitMenuItemActionPerformed (evt);
          }
        }
        );
    
        fileMenu.add (exitMenuItem);
      menuBar.add (fileMenu);
      editMenu.setText ("Edit");
  
        cutMenuItem.setText ("Cut");
    
        editMenu.add (cutMenuItem);
        copyMenuItem.setText ("Copy");
    
        editMenu.add (copyMenuItem);
        pasteMenuItem.setText ("Paste");
    
        editMenu.add (pasteMenuItem);
        deleteMenuItem.setText ("Delete");
    
        editMenu.add (deleteMenuItem);
      menuBar.add (editMenu);
      ConfigurationMenu.setText ("Configuration");
  
        compNewMenu.setText ("New");
        compNewMenu.setToolTipText ("Creates new components");
        compNewMenu.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/New.gif")));
    
          compNewContainerMenuItem.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/NewConfiguration.gif")));
          compNewContainerMenuItem.setToolTipText ("Creates a new configuration");
          compNewContainerMenuItem.setText ("Configuration...");
          compNewContainerMenuItem.addActionListener (new java.awt.event.ActionListener () {
            public void actionPerformed (java.awt.event.ActionEvent evt) {
              NewContainerActionPerformed (evt);
            }
          }
          );
      
          compNewMenu.add (compNewContainerMenuItem);
          compNewFileSourceMenuItem.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/NewFileSource.gif")));
          compNewFileSourceMenuItem.setToolTipText ("Creates a new file source");
          compNewFileSourceMenuItem.setText ("File Source...");
          compNewFileSourceMenuItem.addActionListener (new java.awt.event.ActionListener () {
            public void actionPerformed (java.awt.event.ActionEvent evt) {
              NewFileSourceActionPerformed (evt);
            }
          }
          );
      
          compNewMenu.add (compNewFileSourceMenuItem);
          compNewFilterMenuItem.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/NewDataFilter.gif")));
          compNewFilterMenuItem.setToolTipText ("Creates a new filter");
          compNewFilterMenuItem.setText ("Filter...");
          compNewFilterMenuItem.addActionListener (new java.awt.event.ActionListener () {
            public void actionPerformed (java.awt.event.ActionEvent evt) {
              NewFilterActionPerformed (evt);
            }
          }
          );
      
          compNewMenu.add (compNewFilterMenuItem);
          compNewViewMenuItem.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/NewDataViewer.gif")));
          compNewViewMenuItem.setToolTipText ("Creates a new view");
          compNewViewMenuItem.setText ("View...");
          compNewViewMenuItem.addActionListener (new java.awt.event.ActionListener () {
            public void actionPerformed (java.awt.event.ActionEvent evt) {
              NewViewActionPerformed (evt);
            }
          }
          );
      
          compNewMenu.add (compNewViewMenuItem);
        ConfigurationMenu.add (compNewMenu);
        compDelMenuItem.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/Delete.gif")));
        compDelMenuItem.setToolTipText ("Deletes the selected component");
        compDelMenuItem.setText ("Delete");
        compDelMenuItem.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            compDelMenuActionPerformed (evt);
          }
        }
        );
    
        ConfigurationMenu.add (compDelMenuItem);
    
        ConfigurationMenu.add (jSeparator1);
        compConfigureMenuItem.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/Configure.gif")));
        compConfigureMenuItem.setToolTipText ("Opens the configuration dialog of the selected component");
        compConfigureMenuItem.setText ("Configure...");
        compConfigureMenuItem.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            compConfigureMenuActionPerformed (evt);
          }
        }
        );
    
        ConfigurationMenu.add (compConfigureMenuItem);
    
        ConfigurationMenu.add (jSeparator2);
        compUpMenuItem.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/ArrowUp.gif")));
        compUpMenuItem.setToolTipText ("Moves the selected component one up");
        compUpMenuItem.setText ("Up");
        compUpMenuItem.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            compUpMenuActionPerformed (evt);
          }
        }
        );
    
        ConfigurationMenu.add (compUpMenuItem);
        compDownMenuItem.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/ArrowDown.gif")));
        compDownMenuItem.setToolTipText ("Moves the selected component one down");
        compDownMenuItem.setText ("Down");
        compDownMenuItem.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            compDownMenuActionPerformed (evt);
          }
        }
        );
    
        ConfigurationMenu.add (compDownMenuItem);
      menuBar.add (ConfigurationMenu);
      helpMenu.setText ("Help");
  
        contentMenuItem.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/Help.gif")));
        contentMenuItem.setText ("Contents");
        contentMenuItem.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            contentMenuItemActionPerformed (evt);
          }
        }
        );
    
        helpMenu.add (contentMenuItem);
        aboutMenuItem.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/About.gif")));
        aboutMenuItem.setText ("About");
        aboutMenuItem.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            aboutMenuItemActionPerformed (evt);
          }
        }
        );
    
        helpMenu.add (aboutMenuItem);
      menuBar.add (helpMenu);
    addWindowListener (new java.awt.event.WindowAdapter () {
      public void windowClosing (java.awt.event.WindowEvent evt) {
        exitForm (evt);
      }
    }
    );

    cfgToolBar.setLayout (new java.awt.FlowLayout (0, 5, 5));

      NewVisualizationToolButton.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/NewVisualization.gif")));
      NewVisualizationToolButton.setToolTipText ("Creates a new visualization from the selected configuration for a new file.");
      NewVisualizationToolButton.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          NewVisualizationToolButtonActionPerformed (evt);
        }
      }
      );
  
      cfgToolBar.add (NewVisualizationToolButton);
  
      RedoVisualizationToolButton.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/CurrentVisualization.gif")));
      RedoVisualizationToolButton.setToolTipText ("Creates a new visualization from the selected configuration for the current file.");
      RedoVisualizationToolButton.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          CurrentVisualizationToolButonActionPerformed (evt);
        }
      }
      );
  
      cfgToolBar.add (RedoVisualizationToolButton);
  
      OpenConfigurationToolButton.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/OpenConfiguration.gif")));
      OpenConfigurationToolButton.setToolTipText ("Opens a configuration file.");
      OpenConfigurationToolButton.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          OpenConfigurationToolButtonActionPerformed (evt);
        }
      }
      );
  
      cfgToolBar.add (OpenConfigurationToolButton);
  
      SaveConfigurationToolButton.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/SaveConfiguration.gif")));
      SaveConfigurationToolButton.setToolTipText ("Saves the selected configuration to a file.");
      SaveConfigurationToolButton.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          SaveConfigurationToolButtonActionPerformed (evt);
        }
      }
      );
  
      cfgToolBar.add (SaveConfigurationToolButton);
  
      cfgNewConfigurationToolButton.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/NewConfiguration.gif")));
      cfgNewConfigurationToolButton.setToolTipText ("Creates a new configuration");
      cfgNewConfigurationToolButton.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          cfgNewConfigurationToolButtonActionPerformed (evt);
        }
      }
      );
  
      cfgToolBar.add (cfgNewConfigurationToolButton);
  
      cfgNewFileSourceToolButton.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/NewFileSource.gif")));
      cfgNewFileSourceToolButton.setToolTipText ("CReates a new file source");
      cfgNewFileSourceToolButton.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          cfgNewFileSourceToolButtonActionPerformed (evt);
        }
      }
      );
  
      cfgToolBar.add (cfgNewFileSourceToolButton);
  
      cfgNewFilterToolButton.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/NewDataFilter.gif")));
      cfgNewFilterToolButton.setToolTipText ("Creates a new filter");
      cfgNewFilterToolButton.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          cfgNewFilterToolButtonActionPerformed (evt);
        }
      }
      );
  
      cfgToolBar.add (cfgNewFilterToolButton);
  
      cfgNewViewToolButton.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/NewDataViewer.gif")));
      cfgNewViewToolButton.setToolTipText ("Creates a new View");
      cfgNewViewToolButton.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          cfgNewViewToolButtonActionPerformed (evt);
        }
      }
      );
  
      cfgToolBar.add (cfgNewViewToolButton);
  
      cfgDeleteToolButton.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/Delete.gif")));
      cfgDeleteToolButton.setToolTipText ("Deletes the selected component");
      cfgDeleteToolButton.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          cfgDeleteToolButtonActionPerformed (evt);
        }
      }
      );
  
      cfgToolBar.add (cfgDeleteToolButton);
  
      cfgConfigureToolButton.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/Configure.gif")));
      cfgConfigureToolButton.setToolTipText ("Opens the configuration dialog of the selected component");
      cfgConfigureToolButton.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          cfgConfigureToolButtonActionPerformed (evt);
        }
      }
      );
  
      cfgToolBar.add (cfgConfigureToolButton);
  
      cfgUpToolButton.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/ArrowUp.gif")));
      cfgUpToolButton.setToolTipText ("Moves the selected component one up");
      cfgUpToolButton.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          cfgUpToolButtonActionPerformed (evt);
        }
      }
      );
  
      cfgToolBar.add (cfgUpToolButton);
  
      cfgDownToolButton.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/ArrowDown.gif")));
      cfgDownToolButton.setToolTipText ("Moves the selected component one down");
      cfgDownToolButton.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          cfgDownToolButtonActionPerformed (evt);
        }
      }
      );
  
      cfgToolBar.add (cfgDownToolButton);
  
      AboutToolButton.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/About.gif")));
      AboutToolButton.setToolTipText ("Opens the about dialog.");
      AboutToolButton.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          AboutToolButtonActionPerformed (evt);
        }
      }
      );
  
      cfgToolBar.add (AboutToolButton);
  
      HelpToolButton.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/YARB/images/Help.gif")));
      HelpToolButton.setToolTipText ("Opens the online help.");
      HelpToolButton.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          HelpToolButtonActionPerformed (evt);
        }
      }
      );
  
      cfgToolBar.add (HelpToolButton);
  

    getContentPane ().add (cfgToolBar, java.awt.BorderLayout.NORTH);


  
      scrollPane.setViewportView (desktopPane);
  

    getContentPane ().add (scrollPane, java.awt.BorderLayout.CENTER);

    setJMenuBar (menuBar);

  }//GEN-END:initComponents

  private void CurrentVisualizationMenuItemActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CurrentVisualizationMenuItemActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.doRedoCurrentVisualization(); 
  }//GEN-LAST:event_CurrentVisualizationMenuItemActionPerformed

  private void CurrentVisualizationToolButonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CurrentVisualizationToolButonActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.doRedoCurrentVisualization();
  }//GEN-LAST:event_CurrentVisualizationToolButonActionPerformed

  private void SaveConfigurationToolButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SaveConfigurationToolButtonActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.doSaveConfiguration();
  }//GEN-LAST:event_SaveConfigurationToolButtonActionPerformed

  private void OpenConfigurationToolButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OpenConfigurationToolButtonActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.doOpenConfiguration();
  }//GEN-LAST:event_OpenConfigurationToolButtonActionPerformed

  private void NewVisualizationToolButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_NewVisualizationToolButtonActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.doCreateNewVisualization();
  }//GEN-LAST:event_NewVisualizationToolButtonActionPerformed

  private void SaveAsMenuItemActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SaveAsMenuItemActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.doSaveConfiguration();
  }//GEN-LAST:event_SaveAsMenuItemActionPerformed

  private void OpenCfgMenuItemActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OpenCfgMenuItemActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.doOpenConfiguration();
  }//GEN-LAST:event_OpenCfgMenuItemActionPerformed

  private void NewVisualizationMenuItemActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_NewVisualizationMenuItemActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.doCreateNewVisualization();
  }//GEN-LAST:event_NewVisualizationMenuItemActionPerformed

  private void HelpToolButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_HelpToolButtonActionPerformed
// Add your handling code here:
    YHTMLViewerDialog dlg =new YHTMLViewerDialog (null, "YARB Online Help",false);
    URL url= getClass().getResource("/YARB/Html/Help/Help.html");
    dlg.setPage(url);
    dlg.show();
  }//GEN-LAST:event_HelpToolButtonActionPerformed

  private void AboutToolButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AboutToolButtonActionPerformed
// Add your handling code here:
    YHTMLViewerDialog dlg =new YHTMLViewerDialog (this, "About YARB",true);
    URL url= getClass().getResource("/YARB/Html/About/About.html");
    dlg.setPage(url);
    dlg.show();
  }//GEN-LAST:event_AboutToolButtonActionPerformed

  private void aboutMenuItemActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutMenuItemActionPerformed
// Add your handling code here:
    YHTMLViewerDialog dlg =new YHTMLViewerDialog (this, "About YARB",true);
    URL url= getClass().getResource("/YARB/Html/About/About.html");
    dlg.setPage(url);
    dlg.show();
  }//GEN-LAST:event_aboutMenuItemActionPerformed

  private void contentMenuItemActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_contentMenuItemActionPerformed
// Add your handling code here:
    YHTMLViewerDialog dlg =new YHTMLViewerDialog (null, "YARB Online Help",false);
    URL url= getClass().getResource("/YARB/Html/Help/Help.html");
    dlg.setPage(url);
    dlg.show();
  }//GEN-LAST:event_contentMenuItemActionPerformed

  private void cfgDownToolButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cfgDownToolButtonActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.doMoveDown();
  }//GEN-LAST:event_cfgDownToolButtonActionPerformed

  private void cfgUpToolButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cfgUpToolButtonActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.doMoveUp();
  }//GEN-LAST:event_cfgUpToolButtonActionPerformed

  private void cfgConfigureToolButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cfgConfigureToolButtonActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.doConfigure();
  }//GEN-LAST:event_cfgConfigureToolButtonActionPerformed

  private void cfgDeleteToolButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cfgDeleteToolButtonActionPerformed
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.doDelete();
// Add your handling code here:
  }//GEN-LAST:event_cfgDeleteToolButtonActionPerformed

  private void cfgNewViewToolButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cfgNewViewToolButtonActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.addNewDataView();
  }//GEN-LAST:event_cfgNewViewToolButtonActionPerformed

  private void cfgNewFilterToolButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cfgNewFilterToolButtonActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.addNewDataFilter();
  }//GEN-LAST:event_cfgNewFilterToolButtonActionPerformed

  private void cfgNewFileSourceToolButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cfgNewFileSourceToolButtonActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.addNewFileSource();
  }//GEN-LAST:event_cfgNewFileSourceToolButtonActionPerformed

  private void cfgNewConfigurationToolButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cfgNewConfigurationToolButtonActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.addNewContainer();
  }//GEN-LAST:event_cfgNewConfigurationToolButtonActionPerformed

  private void compDownMenuActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_compDownMenuActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.doMoveDown();
  }//GEN-LAST:event_compDownMenuActionPerformed

  private void compUpMenuActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_compUpMenuActionPerformed
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.doMoveUp();
// Add your handling code here:
  }//GEN-LAST:event_compUpMenuActionPerformed

  private void compConfigureMenuActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_compConfigureMenuActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.doConfigure();
  }//GEN-LAST:event_compConfigureMenuActionPerformed

  private void compDelMenuActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_compDelMenuActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.doDelete();
  }//GEN-LAST:event_compDelMenuActionPerformed

  private void NewViewActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_NewViewActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.addNewDataView();
  }//GEN-LAST:event_NewViewActionPerformed

  private void NewFilterActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_NewFilterActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.addNewDataFilter();   
  }//GEN-LAST:event_NewFilterActionPerformed

  private void NewFileSourceActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_NewFileSourceActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.addNewFileSource();
  }//GEN-LAST:event_NewFileSourceActionPerformed

  private void NewContainerActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_NewContainerActionPerformed
// Add your handling code here:
    YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();
    dir.addNewContainer();
  }//GEN-LAST:event_NewContainerActionPerformed

  private void exitMenuItemActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuItemActionPerformed
    System.exit (0);
  }//GEN-LAST:event_exitMenuItemActionPerformed

  /** Exit the Application */
  private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
    System.exit (0);
  }//GEN-LAST:event_exitForm

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JMenuBar menuBar;
  private javax.swing.JMenu fileMenu;
  private javax.swing.JMenuItem NewVisualizationMenuItem;
  private javax.swing.JMenuItem RedoVisualizationMenuItem;
  private javax.swing.JSeparator jSeparator3;
  private javax.swing.JMenuItem OpenCfgMenuItem;
  private javax.swing.JMenuItem SaveCfgMenuItem;
  private javax.swing.JSeparator jSeparator4;
  private javax.swing.JMenuItem exitMenuItem;
  private javax.swing.JMenu editMenu;
  private javax.swing.JMenuItem cutMenuItem;
  private javax.swing.JMenuItem copyMenuItem;
  private javax.swing.JMenuItem pasteMenuItem;
  private javax.swing.JMenuItem deleteMenuItem;
  private javax.swing.JMenu ConfigurationMenu;
  private javax.swing.JMenu compNewMenu;
  private javax.swing.JMenuItem compNewContainerMenuItem;
  private javax.swing.JMenuItem compNewFileSourceMenuItem;
  private javax.swing.JMenuItem compNewFilterMenuItem;
  private javax.swing.JMenuItem compNewViewMenuItem;
  private javax.swing.JMenuItem compDelMenuItem;
  private javax.swing.JSeparator jSeparator1;
  private javax.swing.JMenuItem compConfigureMenuItem;
  private javax.swing.JSeparator jSeparator2;
  private javax.swing.JMenuItem compUpMenuItem;
  private javax.swing.JMenuItem compDownMenuItem;
  private javax.swing.JMenu helpMenu;
  private javax.swing.JMenuItem contentMenuItem;
  private javax.swing.JMenuItem aboutMenuItem;
  private javax.swing.JToolBar cfgToolBar;
  private javax.swing.JButton NewVisualizationToolButton;
  private javax.swing.JButton RedoVisualizationToolButton;
  private javax.swing.JButton OpenConfigurationToolButton;
  private javax.swing.JButton SaveConfigurationToolButton;
  private javax.swing.JButton cfgNewConfigurationToolButton;
  private javax.swing.JButton cfgNewFileSourceToolButton;
  private javax.swing.JButton cfgNewFilterToolButton;
  private javax.swing.JButton cfgNewViewToolButton;
  private javax.swing.JButton cfgDeleteToolButton;
  private javax.swing.JButton cfgConfigureToolButton;
  private javax.swing.JButton cfgUpToolButton;
  private javax.swing.JButton cfgDownToolButton;
  private javax.swing.JButton AboutToolButton;
  private javax.swing.JButton HelpToolButton;
  private javax.swing.JScrollPane scrollPane;
  private javax.swing.JDesktopPane desktopPane;
  // End of variables declaration//GEN-END:variables

/** 
 * Add a JInternalFrame to the main frame pane
 * @author  Thomas
 * @version 
 */  
  public void AddFrame(JInternalFrame frame)
  {   
	frame.setVisible(true); //necessary as of kestrel
        desktopPane.add(frame);
        try 
        {
            frame.setSelected(true);
        } catch (java.beans.PropertyVetoException e) 
        {
        }
  }
  
  
  
  public void updateMenu()
  {
        YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();

        // Enable menu items:

        NewVisualizationMenuItem.setEnabled(dir.canCreateNewVisualization());
        RedoVisualizationMenuItem.setEnabled(dir.canCreateNewVisualization());
        OpenCfgMenuItem.setEnabled(dir.canOpenConfiguration());
        SaveCfgMenuItem.setEnabled(dir.canSaveConfiguration());
        
        compNewContainerMenuItem.setEnabled(dir.canAddNewContainer());
        compNewFileSourceMenuItem.setEnabled(dir.canAddNewFileSource());
        compNewFilterMenuItem.setEnabled(dir.canAddNewDataFilter());
        compNewViewMenuItem.setEnabled(dir.canAddNewDataView());
        compDelMenuItem.setEnabled(dir.canDelete());
        compConfigureMenuItem.setEnabled(dir.canConfigure());
        compUpMenuItem.setEnabled(dir.canMove());
        compDownMenuItem.setEnabled(dir.canMove());
        
        
        //Not yet implemented:
        
        cutMenuItem.setEnabled(false);
        copyMenuItem.setEnabled(false);
        pasteMenuItem.setEnabled(false);
        deleteMenuItem.setEnabled(false);
  }    
  
  public void updateToolbar()
  {
        YGlobalNavigationDirector dir= YGlobalNavigationDirector.exemplar();

        // Enable tool buttons:

        NewVisualizationToolButton.setEnabled(dir.canCreateNewVisualization());
        RedoVisualizationToolButton.setEnabled(dir.canCreateNewVisualization());
        OpenConfigurationToolButton.setEnabled(dir.canOpenConfiguration());
        SaveConfigurationToolButton.setEnabled(dir.canSaveConfiguration());
        cfgNewConfigurationToolButton.setEnabled(dir.canAddNewContainer());
        cfgNewFileSourceToolButton.setEnabled(dir.canAddNewFileSource());
        cfgNewFilterToolButton.setEnabled(dir.canAddNewDataFilter());
        cfgNewViewToolButton.setEnabled(dir.canAddNewDataView());
        cfgDeleteToolButton.setEnabled(dir.canDelete());
        cfgConfigureToolButton.setEnabled(dir.canConfigure());
        cfgUpToolButton.setEnabled(dir.canMove());
        cfgDownToolButton.setEnabled(dir.canMove());
        
      }
        
      static int m_openFrameCount = 0;
      static final int m_xCreateOffset = 25, m_yCreateOffset = 25;
      static final int m_xStartCreate = 310, m_yStartCreate = 10;
        
    
      public Point GetNextCreationPoint() 
      {
        Point p = new Point(m_xStartCreate+m_xCreateOffset*m_openFrameCount,
                            m_yStartCreate+m_yCreateOffset*m_openFrameCount);
        
        m_openFrameCount++;
        return p;
      }
  
      
   private Cursor m_OriginalCursor;
  
  /**
  *  Sets the wait cursor for the main frame
  */
  public void setWaitCursor()
  {
    ImageIcon cimg= new ImageIcon( getClass().getResource ("/YARB/images/WaitCursor.gif"));
    Cursor cur= getToolkit().createCustomCursor(cimg.getImage(),new Point(12,12), "ArrUp");

    m_OriginalCursor=getCursor();
    setCursor(cur);
  }
  
  /**
  * Restores the original cursor after setting the wait cursor with setWaitCursor
  */
  public void deleteWaitCursor()
  {
    if(m_OriginalCursor!=null)
    {
      setCursor(m_OriginalCursor);
    };
  }
  
}