/*
 * YVNavigator.java
 *
 * Created on 18. April 2000, 22:23
 */
 
package YARB.Main;
import YARB.Interfaces.*;

import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import java.awt.Component;
import java.util.*;

/** 
 *
 * @author  Thomas
 * @version 
 */
public class YVNavigator extends javax.swing.JInternalFrame {

  /** Creates new form YVNavigator */
/*
  public YVNavigator() {
    initComponents ();
  }
*/
  
    protected DefaultMutableTreeNode rootNode;
   // protected DefaultMutableTreeNode m_aktNode;
    protected DefaultTreeModel treeModel;
    
    protected ImageIcon   m_FilterIcon;
    protected ImageIcon   m_ViewerIcon;
    protected ImageIcon   m_FileSourceIcon;
    protected ImageIcon   m_ContainerIcon;
    
  
  
  public YVNavigator(String title)
  {
    super(title,
              true, //resizable
              false, //closable
              false, //maximizable
              true);//iconifiable

    
        rootNode = new DefaultMutableTreeNode(new TreeNodeInfo("YARB Configurations"));
        //m_aktNode=null;
        treeModel = new DefaultTreeModel(rootNode);
        treeModel.addTreeModelListener(new MyTreeModelListener());
        
        m_FilterIcon= new ImageIcon(getClass ().getResource ("/YARB/images/DataFilter.gif"));
        m_ViewerIcon= new ImageIcon(getClass ().getResource ("/YARB/images/DataViewer.gif"));
        m_FileSourceIcon= new ImageIcon(getClass ().getResource ("/YARB/images/FileSource.gif"));
        m_ContainerIcon= new ImageIcon(getClass ().getResource ("/YARB/images/Configuration.gif"));
        
        
        
    
    initComponents();
  
    
    Tree.setModel(treeModel);
    //Tree.setEditable(true);
    Tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
    Tree.setShowsRootHandles(true);
    Tree.setCellRenderer( new MyRenderer());
    
    ToolTipManager.sharedInstance().registerComponent(Tree);

    
    setSize(300,400);
    
    PopulateTree();
  
    YGlobalNavigationDirector dir = YGlobalNavigationDirector.exemplar();
    dir.setVNavigator(this);
    
    dir.setActiveObject(null);

  }
  
  

  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    TreeView = new javax.swing.JScrollPane ();
    Tree = new javax.swing.JTree ();
    getContentPane ().setLayout (new java.awt.BorderLayout ());


      Tree.addTreeSelectionListener (new javax.swing.event.TreeSelectionListener () {
        public void valueChanged (javax.swing.event.TreeSelectionEvent evt) {
          TreeValueChanged (evt);
        }
      }
      );
  
      TreeView.setViewportView (Tree);
  

    getContentPane ().add (TreeView, java.awt.BorderLayout.CENTER);

  }//GEN-END:initComponents

  private void TreeValueChanged (javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_TreeValueChanged
// Add your handling code here:
    YGlobalNavigationDirector dir = YGlobalNavigationDirector.exemplar();
    TreePath tp=evt.getNewLeadSelectionPath();
    if(tp==null){
      return;
    };
    DefaultMutableTreeNode node = (DefaultMutableTreeNode) (tp.getLastPathComponent());
    if(node == null){
      return;
    };
    TreeNodeInfo tni= (TreeNodeInfo) node.getUserObject();
    if(tni==null){
      return;
    }
    dir.setActiveObject(tni.getObject());
  }//GEN-LAST:event_TreeValueChanged


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JScrollPane TreeView;
  private javax.swing.JTree Tree;
  // End of variables declaration//GEN-END:variables

  
      class MyTreeModelListener implements TreeModelListener {
       
        public void treeNodesChanged(TreeModelEvent e) {
            DefaultMutableTreeNode node;
            node = (DefaultMutableTreeNode)
                     (e.getTreePath().getLastPathComponent());

            /*
             * If the event lists children, then the changed
             * node is the child of the node we've already
             * gotten.  Otherwise, the changed node and the
             * specified node are the same.
             */
            try {
                int index = e.getChildIndices()[0];
                node = (DefaultMutableTreeNode)
                       (node.getChildAt(index));
            } catch (NullPointerException exc) {}

            System.out.println("The user has finished editing the node.");
            System.out.println("New value: " + node.getUserObject());
        }
       
        public void treeNodesInserted(TreeModelEvent e) {
        }
        
        public void treeNodesRemoved(TreeModelEvent e) {
        }
        
        public void treeStructureChanged(TreeModelEvent e) {
        }
    }

    
    public void PopulateTree()
    {
      clear();
      
      YVisualizationManager ym= YVisualizationManager.exemplar();
      
      for(int i=0; i< ym.getNumbVContainers();i++)
      {
        IVisualContainer vc= ym.getVContainer(i);
        
        DefaultMutableTreeNode pCont = new DefaultMutableTreeNode(new TreeNodeInfo(vc,m_ContainerIcon));
        rootNode.add(pCont);
        
        IFileSource fs= vc.getFileSource();
        if(fs!=null){
          
          pCont.add( new DefaultMutableTreeNode(new TreeNodeInfo(fs,m_FileSourceIcon)));
        };
        
        for(int k=0; k< vc.numbOfDataFilter(); k++)
        {
          IDataFilter df= vc.getDataFilter(k);
          if(df!=null){
            pCont.add(new DefaultMutableTreeNode(new TreeNodeInfo(df,m_FilterIcon)));
          };
        };
        
        IDataViewer dv= vc.getDataView();
        if(dv!=null) {
          pCont.add(new DefaultMutableTreeNode(new TreeNodeInfo(dv,m_ViewerIcon)));
        };
      };
    }
    
    /**
    * Ensures that the given object is visible
    */
    public void setVisibleObject(IConfigurable o)
    {
      if(o==null)
      {
        return;
      };
     
      // Search for Object. If there are children, then the tree-node should be expanded
      DefaultMutableTreeNode node=searchNodeByObject(rootNode,o);
      if( node != null)
      {
        TreePath path;
        
        if(node.getChildCount()>0)
        {
          DefaultMutableTreeNode chld=(DefaultMutableTreeNode)node.getFirstChild();
          path=new TreePath(chld.getPath());
        }
        else
        {
          path=new TreePath(node.getPath());
        };
        
        Tree.scrollPathToVisible(path);
      };
      
    }
  
    private DefaultMutableTreeNode searchNodeByObject(DefaultMutableTreeNode root, IConfigurable o)
    {
      Enumeration e=root.breadthFirstEnumeration();
      
      while (e.hasMoreElements()) 
      {
         DefaultMutableTreeNode node = (DefaultMutableTreeNode)e.nextElement();
         TreeNodeInfo info= (TreeNodeInfo)node.getUserObject();
         if(info.getObject()==o)
         {
          return node;
         };
      };
      
      return null;
     }
    
    /** Remove all nodes except the root node. */
    protected void clear() {
        rootNode.removeAllChildren();
        treeModel.reload();
    }

    /** Remove the currently selected node. */
    protected void removeCurrentNode() {
        TreePath currentSelection = Tree.getSelectionPath();
        if (currentSelection != null) {
            DefaultMutableTreeNode currentNode = (DefaultMutableTreeNode)
                         (currentSelection.getLastPathComponent());
            MutableTreeNode parent = (MutableTreeNode)(currentNode.getParent());
            if (parent != null) {
                treeModel.removeNodeFromParent(currentNode);
                return;
            }
        } 

//        // Either there was no selection, or the root was selected.
//        toolkit.beep();
    }

    /** Add child to the currently selected node. */
    protected DefaultMutableTreeNode addObject(Object child) {
        DefaultMutableTreeNode parentNode = null;
        TreePath parentPath = Tree.getSelectionPath();

        if (parentPath == null) {
            parentNode = rootNode;
        } else {
            parentNode = (DefaultMutableTreeNode)
                         (parentPath.getLastPathComponent());
        }

        return addObject(parentNode, child, true);
    }

    protected DefaultMutableTreeNode addObject(DefaultMutableTreeNode parent,
                                            Object child) {
        return addObject(parent, child, false);
    }

    protected DefaultMutableTreeNode addObject(DefaultMutableTreeNode parent,
                                            Object child, 
                                            boolean shouldBeVisible) {
        DefaultMutableTreeNode childNode = 
                new DefaultMutableTreeNode(child);

        if (parent == null) {
            parent = rootNode;
        }

        treeModel.insertNodeInto(childNode, parent, 
                                 parent.getChildCount());

        // Make sure the user can see the lovely new node.
        if (shouldBeVisible) {
            Tree.scrollPathToVisible(new TreePath(childNode.getPath()));
        }
        return childNode;
    }
    
    
    
    private class TreeNodeInfo    
    {
        private ImageIcon m_Icon;
        private IConfigurable m_Object;
        private String        m_strName;
        
        public TreeNodeInfo(IConfigurable o, ImageIcon ico)
        {
          m_Object=o;
          m_Icon=ico;
          m_strName="";
        }
        
        public TreeNodeInfo(String strName)
        {
          m_Object=null;
          m_Icon=null;
          m_strName=strName;
        }
        
        public ImageIcon getIcon(){
          return m_Icon;
        }
        
        public IConfigurable getObject(){
          return m_Object;
        }
        
        public String toString() {
            if(m_Object != null) return m_Object.getName();
            return m_strName;
        }
    }
        

    private class MyRenderer extends DefaultTreeCellRenderer {

        public MyRenderer() {
        }

        public Component getTreeCellRendererComponent(
                            JTree tree,
                            Object value,
                            boolean sel,
                            boolean expanded,
                            boolean leaf,
                            int row,
                            boolean hasFocus) {

            super.getTreeCellRendererComponent(
                            tree, value, sel,
                            expanded, leaf, row,
                            hasFocus);

            
             DefaultMutableTreeNode node =(DefaultMutableTreeNode)value;
             TreeNodeInfo nodeInfo = (TreeNodeInfo)(node.getUserObject());
             if(nodeInfo.getIcon()!=null){
              setIcon(nodeInfo.getIcon());
             };
             if(nodeInfo.getObject() != null){
              setToolTipText(nodeInfo.getObject().toString());
             };
            return this;
        }
   }
    
}