/*
 * YXMLConfigurationReader.java
 *
 * Created on 3. Juni 2000, 14:19
 */
 
package YARB.XML;

import YARB.XML.YXMLReader;
import YARB.Interfaces.*;
import java.util.*;
/** 
 *
 * @author  Administrator
 * @version 
 */
public class YXMLConfigurationReader extends YXMLReader 
implements IConfigurationReader, ICfgFileRead
{    
  
  /** Creates new YXMLConfigurationReader */
  public YXMLConfigurationReader() {
  }
  /** Creates new YXMLConfigurationReader and sets the XMlSource*/
  public YXMLConfigurationReader(String src) {
    SetXMLSource(src);   
  }
  
  /** Set XML Source File */
  public void SetXMLSourceFile(String src) {
    SetXMLSource(src);
  }
  /** Opens a tree node with the given name.
   */
  public void OpenNode(String NodeName) throws ECfgReaderError {
   // if( GetCurrentNode() != null ) {   
   //   throw new ECfgReaderError("Error opening new node -> last node has to be closed first : " + this.toString());      
   // }
    try {
      SetCurrentNode( FindNode(NodeName) );
     } catch (YXMLReader.ECfgReaderCGeneralError e1) {
      throw new ECfgReaderError( e1.toString() + " " + this.toString() );
    } 
  }
  /** Closes the last actual tree node
   */
  public void CloseNode() {
    ResetNode();
  }
  /** Reads the class name
   */
  public String GetClass() throws ECfgReaderError {
    if( GetCurrentNode() == null ) {
      throw new ECfgReaderError("Error no node was yet opened : " + this.toString());
    }
    try {
      return getElement("Class");
    } catch (YXMLReader.ECfgReaderCGeneralError e1) {
      throw new ECfgReaderError( e1.toString() + " " + this.toString() );
    }      
  }
  /** Reads the title
   */
  public String getTitle() throws ECfgReaderError {    
    if( GetCurrentNode() == null ) {
      throw new ECfgReaderError("Error no node was yet opened : " + this.toString());
    }
    try {
      return getElement("Title");
    } catch (YXMLReader.ECfgReaderCGeneralError e1) {      
      throw new ECfgReaderError( e1.toString() + " " + this.toString() );
    }      
  }
  /** Reads the file name only for FileSources
   */
  public String getFile() throws ECfgReaderError {
    if( GetCurrentNode() == null ) {
      throw new ECfgReaderError("Error no node was yet opened : " + this.toString());
    }    
    try {
      return getElement("File");
    } catch (YXMLReader.ECfgReaderCGeneralError e1) {      
      throw new ECfgReaderError( e1.toString() + " " + this.toString() );
    }            
  }
  /** Reads a boolean value that has the given name.
   */
  public boolean getBoolean() throws ECfgReaderError {
    if( GetCurrentNode() == null ) {
      throw new ECfgReaderError("Error no node was yet opened : " + this.toString());
    }
    try {
      Boolean BOOLEAN = new Boolean(getElement("boolean"));
      return BOOLEAN.booleanValue();
    } catch( NumberFormatException e ) {
      throw new ECfgReaderError( e.toString() + " " + this.toString() );    
    } catch (YXMLReader.ECfgReaderCGeneralError e1) {      
      throw new ECfgReaderError( e1.toString() + " " + this.toString() );
    }            
  }
  /** Reads a integer value that has the given name.
   */
  public int getInt() throws ECfgReaderError {
    if( GetCurrentNode() == null ) {
      throw new ECfgReaderError("Error no node was yet opened : " + this.toString());
    }
    try {
      Integer INT = new Integer(getElement("int"));
      return INT.intValue();
    } catch( NumberFormatException e ) {
      throw new ECfgReaderError( e.toString() + " " + this.toString() );
    } catch (YXMLReader.ECfgReaderCGeneralError e1) {      
      throw new ECfgReaderError( e1.toString() + " " + this.toString() );
    }           
  }
  /** Reads a float value that has the given name.
   */
  public float getfloat() throws ECfgReaderError {
    if( GetCurrentNode() == null ) {
      throw new ECfgReaderError("Error no node was yet opened : " + this.toString());
    }
    try { 
      Float FLOAT = new Float(getElement("float"));
      return FLOAT.floatValue();
    } catch( NumberFormatException e ) {
      throw new ECfgReaderError( e.toString() + " " + this.toString() );      
    } catch (YXMLReader.ECfgReaderCGeneralError e1) {      
      throw new ECfgReaderError( e1.toString() + " " + this.toString() );
    }            
  }
  /** Reads a string value that has the given name.
   */
  public String getString() throws ECfgReaderError {
    if( GetCurrentNode() == null ) {
      throw new ECfgReaderError("Error no node was yet opened : " + this.toString());
    }
    try { 
      return getElement("String");
    } catch (YXMLReader.ECfgReaderCGeneralError e1) {      
      throw new ECfgReaderError( e1.toString() + " " + this.toString() );
    }          
  }
  
  public void Open(String strPath) throws ECfgFileReadError {
    try {
      SetXMLSource(strPath);
      ParseXML();
    } catch (ECfgReaderCGeneralError e) {
      throw new ECfgFileReadError( e.toString() + " " + this.toString() );
    }
  }
  
  public void Close() {
    ResetAll();
  }
  
  public IConfigurationReader getReader() {
    return this;
  }
}